//the ASTER@IDS game flight modeland related functions
#ifndef AFLIGHT_H
#define AFLIGHT_H

#include "ashared.h" // zone & player defs
#include "asprite.h" // Sprite & SpriteManager

class FlightModel
{
public:
  FlightModel(void)
    : invinc(0), warpTime(-1)
  {}

  int start(Shared* s);
  void go(void);
  void run(void);

  void drawWalls(void);

  void consume(void);
  void shipControl(void);

  void doBoss(void);

  void draw(void);

  void useItem(ItemType *i = NULL);
  void randomEffect(int what, int subWhat);
  void itemOnOff(ItemType *i, int call = 1);

  void blankBackground(void);

  void warpOn(int wt);

protected:
  SpriteManager *sm;
  Sprite *shipNose, *shipBody, *shipFire;

  int x, y, dx, dy, distance, opening, invinc;
  int bfc, bbc, bp; // boss stuff.
  int subgamestat;
  int warpSound, wsInc, warpTime, invincTime;
  int speed, currentSpeed, oldbc, perilBonus;
  float fuelRate, fuelEff, manuverPenalty, regRate;
  Shared *shared;
};

#endif
