#include "gamefunc.h"
#include "aitem.h"
#include "asprite.h"

void ItemType::set(int id, int m, int f, char c, char l, char* n)
{
  iAm = id;
  color = c;
  letter = l;
  useable = (CU_MAP*m) | (CU_FLIGHT*f);
  strcpy(name, n);
  strcpy(description, "");

  iconX = 0;
  iconY = 0;

  init(1, 1, 0);
}

void ItemType::init(int pp, int pu, int own, int p, int o,
                    int over, int mx)
{
  pUp = pp;
  pUse = pu;
  power = p;
  useable &= ~CU_OWNED;
  useable |= (CU_OWNED*own);
  on = o;
  overflow = over;
  max = mx;
  dirty = ALOT;
  iconBack = CYAN;
}

void ItemType::describeWorded(int x1, int y1, int x2, int y2)
{

  int x = x1, y = y1, length;
  unsigned char *start;

  start = description;

  gotoxy(x1, y1);

  while( !(*start == '\0' || y > y2) )
  {
    length = 0;

    while ( !(start[length] == ' ' || start[length] == '\0' || length > 100) )
    {
      length++;
      if (kbhit()) break;
    }
    length++;

    if (x + length > x2)
    {
      for (int a = x;a < x2;a++)
        putch(' ');
      x = x1;
      y++;
      gotoxy(x, y);
    }
    x += length;

    for (;length > 0;length--)
      putch(*(start++));

    if (getkey())
      break;
  }

}

// shows power bars
void ItemType::updateBar(int lr, int caller)
{
  if (dirty < ALITTLE)
    return;

  int lnum, a, dnum, num = power;
  int l;

  if (num < 0)
    num = 0;

  lnum = (num/100);
  if (lnum > 16)
    lnum = 16;

  cset(color, LIGHTGRAY);

  if (dirty > ALITTLE)
  {
    if (on)
      l = LIGHTGREEN;
    else if ( (iAm == T_LASER && power%50 >= pUse)
           || (iAm != T_LASER && power >= pUse) )
      l = GREEN;
    else
      l = BLACK;

    if ( l != BLACK && !(useable & caller) )
      l += RED - GREEN;

    gotoxy(lr, 19);
    putch(letter);
    cset(l, LIGHTGRAY);
    putch(P_SMSQUARE);

    cset(color, LIGHTGRAY);

    for (a = 2;a < 18;a++)
    {
      gotoxy(lr, a);
      putch(' ');
    }
    for (a = 2;a < 18;a++)
    {
      gotoxy(lr+1, a);
      putch(' ');
    }
    for (a = 18;a > 18-lnum;a--)
    {
      gotoxy(lr+1, a);
      putch(P_BIGSQUARE);
    }
  }
 
  gotoxy(lr+1, 18-lnum);
  lnum = (num/50);

  if (lnum%2 != 0)
    putch(P_BOTTOM);
  else
    putch(' ');

  num = num - (lnum*50);
  dnum = num%3;
  lnum = num/3;

  if (lnum == 16)
    dirty += ALOT;

  if (dirty > ALITTLE)
  {
    for (a = 18;a > 18-lnum;a--)
    {
      gotoxy(lr, a);
      putch(240);
    }
  }

  gotoxy(lr, 18-lnum);

  if (dnum == (2))
    putch('=');
  else if (dnum == (1))
    putch('-');
  else if (dnum == (0))
    putch(' ');

  if (dirty < ALOT && lnum > 0)
  {
    gotoxy(lr, 19-lnum);
    putch(240);
  }

  dirty = 0;
}

void ItemType::updateIcon(void)
{
  if (iconX != 0 && iconY != 0 && iconBack != -1)
  {
    gotoxy(iconX, iconY);

    if (!(useable & CU_OWNED))
      cset(DARKGRAY, BLACK);
    else if (power >= pUse)
      cset(color, iconBack);
    else
      cset(BLACK, iconBack);
    putch(letter);
  }    
}

void ItemType::updateInfo(int howMuch)
{
  cset(LIGHTGRAY);

  if (howMuch >= ALOT)
  {
    gotoxy(27,22);
    cputs(name);
    gotoxy(27,23);
    cputs("             ");
  }

  if (howMuch >= ALITTLE)
  {
    gotoxy(27,23);

    switch(iAm)
    {
      case T_FUEL:
        cprintf(" %d  ", power);
        break;
      case T_LASER:
        cprintf("L%d (%d%%)  ", power/50, (int)( (power%50)*2.06 ) );
        break;
      case T_HITS:
        cprintf("%d hits ", power/pUse);
        break;
      case T_GAINITEM:
      case T_PING:
      case T_BOMBARD:
      case T_SEED:
        cprintf("%d uses ", power/pUse);
        break;
      case T_RADAR:
        cprintf("range: %.1f ", (float)power/(float)pUse);
        break;
      default:
        cprintf("power: %d  ", power);
        break;
    }
  }
}

int ItemType::take(void)
{
  if (power + pUp > max)
    return overflow;

  power += pUp;

  if (pUp > 1)
    soil(ALOT);
  else
    soil();

  return -1;
}

void ItemType::genericUse(Zone &zone)
{
  if (power < pUse && iAm != T_RANDOM)
  {
    speaker.play(50);
    return;
  }

  switch (iAm)
  {
    case T_PHASE:
    case T_SHIELD:
      if (on)
        on = 0;
      else
        on = 1;
      soil(ALOT);
      break;
    case T_SLOWDOWN:
      speaker.play(500);
      usePower();
      zone.deltaSpeed--; // slowdown
      break;
    case T_FUEL:
      speaker.play(500);
      zone.deltaSpeed++;
      break;
  }

}

void ItemType::genericOnOff(void)
{
  if (on)
  {
    switch(iAm)
    {
      default: break;
    }
  }
  else
  {
    switch(iAm)
    {
      default: break;
    }
  }
  soil(ALOT);
}   

