//the map model for ASTER@IDS
#ifndef AMAP_H
#define AMAP_H

#include "ashared.h"
#include "mapfunc.h"

enum mapReturnValue {MRV_EXIT = 1, MRV_FINAL = 2, MRV_FLIGHT = 3, MRV_SKIP = 4};

class MapModel
{
public:
  void initialize(void);
  int start(Shared *s);
  void run(void);

  void control(void);
  void update(void);

  void genericControl(int key);
  void scannerControl(int key);
  void radarControl(int key);

  void updateScanner(void);
  void updateRadar(void);
  void switchToRadar(void);
  void switchToScanner(void);

  void advance(void);
  void decideRadarCursor(void);

  void hide(void);
  void reveal(void);
  void nearReveal(int rx, int ry, float range);
  inline void showspot(int sx, int sy);
  void refreshSquare(int sx, int sy);

  void useItem(ItemType *i = NULL);
  void reduceSquare(int wx, int wy);

  void load(void)
    {loadMap(&zone);}
  void makeItFreakingRandom(void)
    {randomMap(zone);}

protected:
  int zone[MAPXSIZE][MAPYSIZE];
  Shared* shared;
  int newx, newy, screen, pic;
  int linech, cheat;
  int x, y, relcur, relnew;
  int subgamestat;
};

#endif
