// aplayer.cpp

#include <conio.h>
#include <stdio.h>
#include "gamefunc.h"
#include "aplayer.h"

void Player::initialize(void)
{
  itemA = T_NONE;
  itemB = T_NONE;

  take = T_NONE;
  subTake = T_NONE;
  plusSkip = 0;
  experience = 0;
  setTakeName("");
  clearMessage();
  placeMessage(1,1);

  next = 0;
  visibleInvinc = 0;

  //                    id         m f  color    icon name
  items[T_NONE]    .set(T_NONE,    0,0, BLACK,   'X', "             ");
  items[T_FUEL]    .set(T_FUEL,    1,1, RED,     'F', "Fuel         ");
  items[T_SLOWDOWN].set(T_SLOWDOWN,1,1, RED,     174, "Slowdown     ");
  items[T_GAINITEM].set(T_GAINITEM,1,1, WHITE,   '+', "Gain Item    ");
  items[T_HITS]    .set(T_HITS,    0,0, MAGENTA, 'H', "Armor        ");

  items[T_SHIELD]  .set(T_SHIELD,  1,1, BLUE,    'S', "Shield       ");
  items[T_LASER]   .set(T_LASER,   0,1, WHITE,   'L', "F. Reflector ");
  items[T_SUPERFR] .set(T_SUPERFR, 0,1, BROWN,   232, "Super F. R.  ");
  items[T_PHASE]   .set(T_PHASE,   1,1, YELLOW,  'S', "Phase Shield ");

  items[T_RADAR]   .set(T_RADAR,   0,0,LIGHTGREEN,'R',"Radar Range  ");
  items[T_RANDSQ]  .set(T_RANDSQ,  1,0,LIGHTGREEN,'?',"Dead Drone   ");
  items[T_CHOOSESQ].set(T_CHOOSESQ,1,0,LIGHTGREEN,2,  "Lost Drone   ");
  items[T_PING]    .set(T_PING,    1,0,LIGHTGREEN,15, "Radar Pulse  ");

  items[T_BOMBARD] .set(T_BOMBARD, 1,1, RED,     15,  "Bombard      ");
  items[T_SEED]    .set(T_SEED,    1,1, WHITE,   15,  "Seed         ");

  items[T_WARP]    .set(T_WARP,    1,1, YELLOW,  21,  "Warp         ");
  items[T_RANDOM]  .set(T_RANDOM,  0,1, WHITE,   '?', "Random       ");

  //                     pup use own init on
  items[T_NONE]    .init(0,  0,  0, 0,    0);

  items[T_FUEL]    .init(7,  1,  1, 1600, 1, T_WARP,     1600);
  items[T_SLOWDOWN].init(1,  1,  0, 0,    0);
  items[T_GAINITEM].init(1,  10, 0, 0,    0);
  items[T_HITS]    .init(1,  3,  1, 3*3,  0, T_SHIELD,   10*3);

  items[T_SHIELD]  .init(25, 1,  1, 0,    0, T_PHASE,    1600);
  items[T_LASER]   .init(50, 49, 1, 0,    0, T_SUPERFR,  (25*50)+49);
  items[T_SUPERFR] .init(25, 1,  0, 0,    0);
  items[T_PHASE]   .init(5,  1,  0, 0,    0, T_WARP,     1600);

  items[T_RADAR]   .init(1,  10, 1, 10,   0, T_PING,     20*10);
  items[T_RANDSQ]  .init(5,  1,  0, 0,    0);
  items[T_CHOOSESQ].init(1,  1,  0, 0,    0);
  items[T_PING]    .init(1,  3,  0, 0,    0);

  items[T_BOMBARD] .init(1,  4,  0, 0,    0);
  items[T_SEED]    .init(1,  5,  0, 0,    0);

  items[T_WARP]    .init(25, 1,  0, 0,    0, -1,	 610+25);
  items[T_RANDOM]  .init(1,  1,  1, 0,    1, -1,         5);

  IBSetRow(0, T_FUEL, T_SLOWDOWN, T_GAINITEM, T_HITS);
  IBSetRow(1, T_LASER, T_SHIELD, T_SUPERFR, T_PHASE);
  IBSetRow(2, T_RADAR, T_RANDSQ, T_CHOOSESQ, T_PING);
  IBSetRow(3, T_BOMBARD, T_NONE, T_SEED, T_NONE);
  IBSetRow(4, T_WARP, T_NONE, T_RANDOM, T_NONE);

  IBAssignPos(33, 3);

  itemDescLoad();

  switch(difficulty)
  {
    case D_EASY:
      playMode = PM_CLASSIC;
      break;
    case D_MEDIUM:
      playMode = PM_NEW;
      break;
    case D_HARD:
      playMode = PM_NEW;
      break;
    case D_RIDICULOUS:
      playMode = PM_NEW;
      break;
  }

  switch(playMode)
  {
    default:
    case PM_NEW:
      info = &itemB;
      break;
    case PM_CLASSIC:
      info = &itemA;
      break;
  }
}

void Player::switchItem(int &which, int toWhat)
{
  for (int a = 0;a < NUMTRINKETS;a++)
  {
    if (!(items[toWhat].useable & CU_OWNED))
      toWhat++;
    if (toWhat >= NUMTRINKETS)
      toWhat = T_NONE + 1;
  }

  if (toWhat >= NUMTRINKETS)
    toWhat = T_NONE + 1;

  if (!(items[toWhat].useable & CU_OWNED))
    toWhat = T_NONE;

  which = toWhat;
  items[which].soil(ALOT);
}

void Player::plus(int which, int times)
{
  int up = which;

  while (up != -1)
  {
    up = items[up].take();
    if (up != -1)
      which = up;
    else if (times > 1)
    {
      times--;
      up = which;
    }
  }
}

void Player::updateItems(int caller)
{
  int reSoil = 0;

  if (itemA == itemB)
    reSoil = items[itemA].dirty;

  if (items[*info].dirty >= ALITTLE)
    items[*info].updateInfo(ALITTLE);

  items[itemA].updateBar(LEFTBAR, caller);

  if (reSoil)
    items[itemB].soil(reSoil);
  items[itemB].updateBar(RIGHTBAR, caller);

  for (int a = T_NONE;a < NUMTRINKETS;a++)
    items[a].updateIcon();
}

void Player::IBSetRow(int r, int i1, int i2, int i3, int i4)
{
  if (r < 0 || r > NUMBEROFROWS)
    return;

  grid[r][0] = i1;
  grid[r][1] = i2;
  grid[r][2] = i3;
  grid[r][3] = i4;
}

void Player::IBAssignPos(int x, int y)
{
  // drawing positions
  for (int r = 0;r < NUMBEROFROWS;r++)
  {
    for (int c = 0;c < NUMBEROFCOLUMNS;c++)
    {
      if (grid[r][c] != T_NONE)
        items[grid[r][c]].setPos(x+c*2, y+r*2);
    }
  }

  IBNextLists();

}

void Player::IBNextLists(void)
{
  // next lists
  int r2, c2, count;
  for (int r = 0;r < NUMBEROFROWS;r++)
  {
    for (int c = 0;c < NUMBEROFCOLUMNS;c++)
    {
      // next up
      r2 = r;

      count = 0;

      do
      {
        if (--r2 < 0)
          r2 = NUMBEROFROWS-1;
      } while(count++ < NUMBEROFROWS
           && !(items[ grid[r2][0] ].useable & CU_OWNED
             || items[ grid[r2][1] ].useable & CU_OWNED
             || items[ grid[r2][2] ].useable & CU_OWNED
             || items[ grid[r2][3] ].useable & CU_OWNED) );

      c2 = c-1;

      count = 0;

      do
      {
        if (++c2 >= NUMBEROFCOLUMNS)
          c2 = 0;
      } while(count++ < NUMBEROFCOLUMNS
           && !(items[ grid[r2][c2] ].useable & CU_OWNED) );

      nextUp[grid[r][c]] = grid[r2][c2];

      // next down
      r2 = r;

      count = 0;

      do
      {
        if (++r2 >= NUMBEROFROWS)
          r2 = 0;
      } while(count++ < NUMBEROFROWS
           && !(items[ grid[r2][0] ].useable & CU_OWNED
             || items[ grid[r2][1] ].useable & CU_OWNED
             || items[ grid[r2][2] ].useable & CU_OWNED
             || items[ grid[r2][3] ].useable & CU_OWNED) );

      c2 = c-1;

      count = 0;

      do
      {
        if (++c2 >= NUMBEROFCOLUMNS)
          c2 = 0;
      } while(count++ < NUMBEROFCOLUMNS
           && !(items[ grid[r2][c2] ].useable & CU_OWNED) );

      nextDown[grid[r][c]] = grid[r2][c2];

      // figure next left
      c2 = c;

      count = 0;

      do
      {
        if (--c2 < 0)
          c2 = NUMBEROFCOLUMNS-1;
      } while(count++ < NUMBEROFCOLUMNS
           && !(items[ grid[r][c2] ].useable & CU_OWNED) );

      nextLeft[grid[r][c]] = grid[r][c2];

      // figure next right
      c2 = c;

      count = 0;

      do
      {
        if (++c2 >= NUMBEROFCOLUMNS)
          c2 = 0;
      } while(count++ < NUMBEROFCOLUMNS
           && !(items[ grid[r][c2] ].useable & CU_OWNED) );

      nextRight[grid[r][c]] = grid[r][c2];

    }
  }
}

void Player::chooseOrder(int at)
{
  int chosen = 0, selected = 1, autogain, dx = 0, looping, choice, key;
  int queue[4] = {T_NONE, T_HITS, T_GAINITEM, T_NONE};
  int qp = 0;

  switch(difficulty)
  {
    case D_EASY:
      autogain = 5;  //shouldn't actually be used.
      break;
    case D_MEDIUM:
      autogain = 4;
      break;
    case D_HARD:
      autogain = 3;
      break;
    case D_RIDICULOUS:
      autogain = 2;
      break;
  }

  gotoxy(5, at);
  cset(WHITE);
  cputs("Starting");

  cset(BLUE);
  gotoxy(4, at);
  putch(ASC_SS_SE);
  gotoxy(4, at+1);
  putch(ASC_SN_SE);
  for (int a = 0;a < autogain;a++)
    putch(ASC_HALF_S);

  cset(LIGHTGRAY);
  gotoxy(3, at+4);
  putch(ASC_SS_SE); putch(ASC_SW_SE);
  gotoxy(3, at+5);
  putch(ASC_SN_SE); putch(ASC_SW_SE);

  for (int a = 1;a < NUMTRINKETS;a++)
  {
    items[a].useable &= ~CU_OWNED;
    gainOrder[a-1] = a;
  }

  key = LEFT;

  while (chosen < NUMTRINKETS-2)
  {
    gotoxy(5, at+2);
    for (int a = 0;a < NUMTRINKETS-1;a++)
    {
      if (a < chosen)
      {
        if (a < autogain)
          cset(items[gainOrder[a]].color, CYAN);
        else
          cset(items[gainOrder[a]].color, BLACK);
      }
      else
        cset(items[gainOrder[a]].color, LIGHTGRAY);

      putch(items[gainOrder[a]].letter);
    }

    looping = 1;

    while (looping)
    {
      if (queue[qp] != T_NONE)
      {
        for (choice = 0;choice < NUMTRINKETS-1;choice++)
          if (gainOrder[choice] == queue[qp])
            break;
        qp++;
      }
      else if (key == 0)
        while( (key = getkey()) == 0)
          ;

      switch(key)
      {
        case LEFT: dx = -1; break;
        case RIGHT: dx = 1; break;
        case SPACE:
        case ENTER:
          speaker.playFor(700, 50);
          choice = selected;
          break;
      }

      if (dx != 0)
        speaker.playFor(1000, 50);

      if (choice >= 0 && choice < NUMTRINKETS)
      {
        key = gainOrder[choice];
        for (int a = choice;a > chosen;a--)
          gainOrder[a] = gainOrder[a-1];
        gainOrder[chosen++] = key;
        looping = 0;

        while(selected+dx < chosen)
          dx++;
      }

      cset(LIGHTGRAY);
      gotoxy(selected+5, at+3);
      putch(' ');

      if (selected+dx < chosen || selected+dx >= NUMTRINKETS-1)
        dx = 0;

      selected += dx;
      dx = 0;

      gotoxy(selected+5, at+3);
      putch(ASC_SN_SS);
      gotoxy(selected+4, at+4);
      putch(ASC_SW_SE); putch(ASC_SN_SW); putch(' ');

      if (chosen < autogain)
        cset(WHITE, LIGHTGRAY);
      else
        cset(DARKGRAY, LIGHTGRAY);
      gotoxy(5, at+5);
      cprintf(items[gainOrder[selected]].name);


      textbox(1, at+6, 40, 24);
      cset(BROWN);
      items[gainOrder[selected]].describeWorded(2, at+7, 39, 23);

      choice = -1;
      key = 0;

    }
  }

  for (int a = 0;a < autogain;a++)
  {
    items[gainOrder[a]].power += items[gainOrder[a]].pUp * ((autogain-a)-1);
    gainItem();
  }
  switchItem(itemA, gainOrder[0]);
  switchItem(itemB, gainOrder[1]);

  plusSkip = 0;

}

void Player::classicGainOrder(void)
{
  const int LIMIT = NUMTRINKETS-1;
  int t, r;

  // make sure it's initialized
  for (int a = 0;a < LIMIT;a++)
    gainOrder[a] = a+1;

  next = 0;

  // put stuff we don't want to get random power-ups at bottom
  for (int a = 0;a < LIMIT;a++)
  {
    switch(gainOrder[a])
    {
      case T_GAINITEM:
      case T_RANDOM:
      case T_FUEL:
      case T_HITS:
        t = gainOrder[a];
        gainOrder[a] = gainOrder[next];
        gainOrder[next++] = t;
    }
  }

  plusSkip = next;

  // put the owned items on the bottom [order doesn't matter]
  for (int a = next;a < LIMIT;a++)
  {
    for (int b = a;b < LIMIT;b++)
    {
      if (items[gainOrder[b]].useable & CU_OWNED)
      {
        t = gainOrder[a];
        gainOrder[a] = gainOrder[b];
        gainOrder[b] = t;
        next++;
        break;
      }
    }
  }

  // get a random order to be used later
  for (int a = next;a < LIMIT;a++)
  {
    r = random(LIMIT-a) + a;

    t = gainOrder[a];
    gainOrder[a] = gainOrder[r];
    gainOrder[r] = t;
  }
}

void Player::gainItem(void)
{
  if (next >= 0 && next < NUMTRINKETS-1)
  {
    items[gainOrder[next]].power += items[gainOrder[next]].pUp;
    items[gainOrder[next]].soilIcon(CYAN);
    items[gainOrder[next++]].useable |= CU_OWNED;

    IBNextLists();
  }
  else
    speaker.play(50);
}

void Player::IBSelect(int *which, int mode)
{
  if (which != &itemA && which != &itemB)
    return;

  int *infoWas = info;
  items[*which].updateInfo(ALOT);

  int running = 1, t;

  while(running)
  {
    info = which;
    items[*which].soilIcon(random(8));
    updateItems(mode);
    items[*which].soilIcon(CYAN);

    switch(getkey())
    {
      case RIGHT:
        speaker.playFor(1000, 50);
        switchItem(*which, nextRight[*which]);
        items[*which].updateInfo(ALOT);
        break;
      case LEFT:
        speaker.playFor(1000, 50);
        switchItem(*which, nextLeft[*which]);
        items[*which].updateInfo(ALOT);
        break;
      case UP:
        speaker.playFor(1000, 50);
        switchItem(*which, nextUp[*which]);
        items[*which].updateInfo(ALOT);
        break;
      case DOWN:
        speaker.playFor(1000, 50);
        switchItem(*which, nextDown[*which]);
        items[*which].updateInfo(ALOT);
        break;
      case 'b':
      case 'B':
        speaker.playFor(700, 50);
        if (playMode == PM_CLASSIC)
          break;
        else if (which == &itemB)
          running = 0;
        else
          which = &itemB;
        break;
      case 'v':
      case 'V':
        speaker.playFor(700, 50);
        if (which == &itemA)
          running = 0;
        else
          which = &itemA;
        break;
      case ESCAPE:
        speaker.playFor(700, 50);
        running = 0;
        break;
    }

  }

  info = infoWas;
  updateItems(mode);
  updateInfo(ALOT);
}

void Player::itemDescLoad(void)
{
  FILE *infile;
  const int READSIZE = 100;
  const int DSIZE = 500;
  char *buffer, *temp;
  char desc[DSIZE];
  int read, bufferSize = 0, maxBufferSize = READSIZE;
  int which, dp;

  if ((infile = fopen("text.dat","rb")) == NULL)
  {
    perror("\nOpen failed! ");
    return;
  }

  read = 1;

  while(read > 0)
  {
    if (maxBufferSize - bufferSize <= READSIZE)
    {
      temp = new char[maxBufferSize*2];
      if (temp)
      {
        for (int a = 0;a < bufferSize;a++)
          temp[a] = buffer[a];
        delete[] buffer;
        buffer = temp;
        temp = NULL;
        maxBufferSize *= 2;
      }
      else
      {
        cputs("unable to allocate larger buffer");
        getch();
        delete[] buffer;
        return;
      }
    }

    read = fread(buffer+bufferSize, sizeof(char), READSIZE, infile);
    bufferSize += read;
  }
            fclose(infile);

  if (bufferSize < maxBufferSize)
    buffer[bufferSize] = '\0';

  dp = 0;
  which = T_NONE;

  for (int a = 0;a < bufferSize;a++)
  {
    switch (buffer[a])
    {
      case '\0':
        a = bufferSize;
        break;
      case '\r':
        desc[dp++] = ' ';
        break;
      case '\n':
        break;
      case '~':
        if (which != T_NONE)
        {
          desc[dp] = '\0';
          items[which].setDescription(desc);
        }

        switch(buffer[++a])
        {
          case 'X': which = T_NONE; break;
          case 'F': which = T_FUEL; break;
          case 'D': which = T_SLOWDOWN; break;
          case '+': which = T_GAINITEM; break;
          case 'A': which = T_HITS; break;
          case 'S': which = T_SHIELD; break;
          case 'L': which = T_LASER; break;
          case 'U': which = T_SUPERFR; break;
          case 'P': which = T_PHASE; break;
          case 'R': which = T_RADAR; break;
          case 'Q': which = T_RANDSQ; break;
          case 'C': which = T_CHOOSESQ; break;
          case 'G': which = T_PING; break;
          case 'B': which = T_BOMBARD; break;
          case 'E': which = T_SEED; break;
          case 'W': which = T_WARP; break;
          case '?': which = T_RANDOM; break;
          default: which = T_NONE; break;
        }

        a += 2; // eat the carrige return

        dp = 0;
        break;
      default:
        desc[dp++] = buffer[a];
        break;
    }
      
  }

  delete[] buffer;

}

void Player::getPower(void)
{
  if (experience < MAXEXP)
  {
    experience++;

    switch(experience)
    {
      case MAXEXP-1:
        speaker.play(1500);
        break;
      case MAXEXP:
        speaker.play(1000);
	chooseRandomBonus(take, subTake);
        setTakeName(makeRandomName(take, subTake));
        expBar(ALOT);
	setMessage(takeName);
        break;
     }
  }
}

void Player::chooseRandomBonus(int &major, int &minor)
{
  int a = random(100)+1;
  int b = 0;

  for (major = T_NONE;major < NUMTRINKETS;major++)
  {
    b += items[major].probability;
    if (a <= b)
      break;
  }

  minor = random(next-plusSkip)+plusSkip;
  minor = gainOrder[minor];
}

void Player::expBar(int howMuch)
{
  if (experience >= MAXEXP)
  {
    if (howMuch >= ALOT)
    {
      gotoxy(27, 24);
      cset(WHITE+BLINK, RED);
      cputs(takeName);
    }
    return;
  }

  drawBar(27, 24, EXPBARSIZE, (long)experience, (long)MAXEXP,
          LIGHTBLUE, BLUE, howMuch);
}

void Player::invincBar(int howMuch, int setTo)
{
  if (setTo != -1)
    visibleInvinc = setTo;

  drawBar(32, 16, 9, visibleInvinc, 40, YELLOW, LIGHTGRAY, howMuch);
  
}

char* Player::makeRandomName(int byWhat, int subWhat)
{
  int c;
  static char workBuffer[14];

  switch(byWhat)
  {
    default:
      for (c = 1;c < 13;c++)
      {
        workBuffer[c] = items[byWhat].name[c];
      }
      workBuffer[0] = '?';
      break;
    case T_PHASE:
      strcpy(workBuffer, "Invincible   ");
      break;
    case T_HITS:
      strcpy(workBuffer, "Repairs      ");
      break;
    case T_RANDOM:
      if (playMode == PM_CLASSIC)
        strcpy(workBuffer, "Extra Spins  ");
      else
        strcpy(workBuffer, "Double Power ");
      break;
    case T_LASER:
      for (c = 1;c < 13;c++)
      {
        workBuffer[c] = items[subWhat].name[c-1];
      }
      workBuffer[0] = '+';
      break;
    case T_GAINITEM:
    case T_WARP:
    case T_FUEL:
    case T_SUPERFR:
    case T_SLOWDOWN:
      strcpy(workBuffer, items[byWhat].name);
      break;
    case T_SEED:
      strcpy(workBuffer, "@\'s to Junk  ");
      break;
    case T_SHIELD:
      strcpy(workBuffer, "Force Wall   ");
      break;
    case T_PING:
      strcpy(workBuffer, "Ping         ");
      break;
  }
  return workBuffer;
}

void Player::clearMessage(int erase)
{
  if (experience >= MAXEXP)
    setMessage(takeName);
  else
    if (erase)
      setMessage("             ", -1);
    else
      setMessage("");

}

void Player::displayMessage(int whatcolor, char* override)
{
  gotoxy(messageX, messageY);
  cset(whatcolor + LIGHTRED-RED, whatcolor);
  if (override)
    cprintf(override);
  else
    cprintf(message);

  if (messageExpire == 0)
    ; // the most common case
  else if (messageExpire > 0)
  {
    if (--messageExpire == 0)
      clearMessage(1);
  }
  // this case fixes an infinite erasure loop
  else if (messageExpire < 0)
  {
    messageExpire = 0;
    clearMessage();
  }
}


// shortcut for pProbSet
void Player::psc(int f, int l, int u, int p, int h, int d, int r, int e,
                 int w, int g, int fw, int n)
{
  for (int a = 0;a < NUMTRINKETS;a++)
    items[a].probability = 0;

  items[T_FUEL].probability =     f;
  items[T_LASER].probability =    l;
  items[T_SUPERFR].probability =  u;
  items[T_PHASE].probability =    p;
  items[T_HITS].probability =     h;
  items[T_SLOWDOWN].probability = d;
  items[T_RANDOM].probability =   r;
  items[T_SEED].probability =     e;
  items[T_WARP].probability =     w;
  items[T_GAINITEM].probability = g;
  items[T_SHIELD].probability =   fw;
  items[T_PING].probability =     n;
}

void Player::pProbSet(int type)
{
  switch(type)
  {
    //    ful pwr sfr inv rep slw spn @>* wrp itm fwl png
    //    26  31  10  10  02  04  10  04  02  01  xx  xx
    case Z_EMPTY:
      psc(26, 36, 05, 00, 06, 00, 10, 00, 10, 02, 05, 00);
      break;
    case Z_TOP:
    case Z_RIGHT:
    case Z_LEFT:
    case Z_BOTTOM:
    case Z_SLOWHUNK:
    case Z_MEDHUNK:
    case Z_FASTHUNK:
    case Z_SLOWROCK:
    case Z_MEDROCK:
    case Z_FASTROCK:
      psc(16, 42, 05, 04, 02, 04, 10, 04, 02, 01, 10, 00);
      break;
    case Z_SLOWCOMET:
    case Z_MEDCOMET:
    case Z_FASTCOMET:
      psc(16, 41, 03, 15, 02, 04, 10, 04, 02, 01, 02, 00);
      break;
    case Z_SLOWWARP:
    case Z_MEDWARP:
    case Z_FASTWARP:
      psc(16, 31, 18, 10, 02, 04, 10, 02, 04, 01, 02, 00);
      break;
    case Z_SLOWWALL:
    case Z_MEDWALL:
    case Z_FASTWALL:
      psc(21, 46, 00, 05, 02, 04, 10, 04, 02, 01, 05, 00);
      break;                                 
    case Z_SLOWMINE:
    case Z_MEDMINE:
    case Z_FASTMINE:
      psc(16, 41, 02, 00, 02, 04, 10, 04, 02, 01, 02, 16);
      break;
    case Z_DISTROCK:
      psc(16, 41, 10, 10, 02, 04, 10, 02, 04, 01, 00, 00);
      break;
    case Z_DISTCOMET:
      psc(16, 41, 00, 22, 02, 04, 10, 00, 04, 01, 00, 00);
      break;
    case Z_DISTWARP:
      psc(16, 41, 17, 05, 02, 04, 10, 00, 04, 01, 00, 00);
      break;
    case Z_SOLID:
      psc(0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0);
      break;
    case Z_BOSS:
      psc(16, 41, 11, 05, 02, 04, 10, 00, 00, 00, 11, 00);
      break;
    case Z_SECRET:
      psc(40, 50, 00, 00, 04, 04, 00, 00, 00, 02, 00, 00);
      break;
    default:
      psc(0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0);
      break;
    //    ful pwr sfr inv rep slw spn @>* wrp itm fwl png
  }
}

