//the ASTER@IDS game and related functions
#ifndef APLAYER_H
#define APLAYER_H

#include "aitem.h"

const NUMBEROFROWS = 5, NUMBEROFCOLUMNS = 4;

class Player
{
public:
  int itemA, itemB, *info;
  int take, subTake, plusSkip;
  int experience;
  int playMode;

  int nextUp[NUMTRINKETS], nextDown[NUMTRINKETS];
  int nextLeft[NUMTRINKETS], nextRight[NUMTRINKETS];
  int gainOrder[NUMTRINKETS], next;

  ItemType items[NUMTRINKETS];
  char takeName[14];
  char message[81];
  int messageExpire, messageX, messageY;

  void initialize(void);
  void itemDescLoad(void);
  void switchItem(int &which, int toWhat);
  void plus(int which, int times);
  void plus(int times = 1)
    {plus(itemB, times);}
  void updateItems(int caller);
  void updateInfo(int howMuch)
    {items[*info].updateInfo(howMuch);}

  ItemType& active(void)
    {return items[itemA];}
  ItemType& select(void)
    {return items[itemB];}

  void IBSetRow(int r, int i1, int i2, int i3, int i4);

  void IBAssignPos(int x, int y);
  void IBNextLists(void);

  void IBSelect(int *which, int mode);

  void chooseOrder(int at);
  void classicGainOrder(void);
  void gainItem(void);

  void getPower(void);

  void expBar(int howMuch = ALITTLE);
  void invincBar(int howMuch = ALITTLE, int setTo = -1);
  void chooseRandomBonus(int &major, int &minor);
  char* makeRandomName(int byWhat, int subWhat);
  void setTakeName(const char *toWhat)
    {strcpy(takeName, toWhat);}
  void setMessage(const char *toWhat, int expireIn = 0)
    {strcpy(message, toWhat); messageExpire = expireIn;}
  void clearMessage(int erase = 0);
  void displayMessage(int whatcolor, char* override = NULL);
  void placeMessage(int x, int y)
    {messageX = x; messageY = y;}

  void psc(int f, int l, int u, int p, int h, int d, int r, int e,
           int w, int g, int fw, int n);
  void pProbSet(int type);

protected:
  int grid[ NUMBEROFROWS ][ NUMBEROFCOLUMNS ];
  int visibleInvinc;
};

#endif
