#include "gamefunc.h"
#include "escfp23x.h"
#include "aroids.h"

// c++ version of METE@RS II: The Trip Home.
//ties inflight and map together
int Asteroids::start(void)
{
  while (getkey())
    ;

  initialize();

  if (shared.player.playMode == PM_NEW)
  {
    titlebar("game C: ASTER@IDS: The Trip Home",4, 3);
    cset(BROWN);
    gotoxy(1,3);
    cputs("C h o o s e   y o u r   w e a p o n s. ");
    //band-aid, for some reason the above line was causing a CR/space (!?!?)
    while(getkey())  
      ;
    shared.player.chooseOrder(5);
  }
  else
  {
    shared.player.classicGainOrder();
    shared.player.switchItem(shared.player.itemA, T_FUEL);
    shared.player.switchItem(shared.player.itemB, T_RANDOM);
  }

  backDrop();

  frameControl.set(18);
  frameControl.sync();

  while(gamestat == 0)
    run();

  if (shared.player.items[T_FUEL].power < 0)
    shared.player.items[T_FUEL].power = 0;
  if (gamestat == 1)
    shared.player.items[T_FUEL].power = 0;

  fuel = shared.player.items[T_FUEL].power;

  return gamestat;
}

void Asteroids::initialize(void)
{

  fuel = 1600;
  gamestat = 0;

  switch(difficulty)
  {
    case D_EASY:
      map.load();
      //map.makeItFreakingRandom();
      map.hide();
      break;
    case D_MEDIUM:
      //map.load();
      map.makeItFreakingRandom();
      map.hide();
      break;
    case D_HARD:
    case D_RIDICULOUS:
      map.makeItFreakingRandom();
      map.hide();
      break;
  }

  map.initialize();
  shared.player.initialize();

}

void Asteroids::backDrop(void)
{
  //left, top, right, bottom, background, forg.., lines, grid
  cset(BLUE);
  clrscr();
  textbox(1, 1, 25, 25);
  textbox(32, 2, 40, 12, BLACK, WHITE);
  textbox(26, 1, 31, 20, LIGHTGRAY, BLACK, 1);
  textbox(26, 21, 40, 24, BLACK, YELLOW);

  shared.player.expBar(ALOT);
}

void Asteroids::run(void)
{
  switch (map.start(&shared))
  {
    case MRV_EXIT: gamestat = 1; break;
    case MRV_FINAL: gamestat = 2; break;
    case MRV_FLIGHT: gamestat = 0; break;
    case MRV_SKIP: gamestat = 3; break;
  }
  if (gamestat == 3)
  {
    for (int a = 1000;a > 0;a -= 50)
    {
      speaker.play(a);
      delay(50);
    }
    speaker.stop();
    gamestat = 0;
  }
  else if (gamestat != 1)
  {
    switch (flight.start(&shared))
    {
      case 1: gamestat = 1; break;
    }
  }

}

void Asteroids::instructions(void)
{

  initialize(); // makes sure the item defs are loaded

  titlebar("game C: ASTER@IDS: The Trip Home",4, 3);
  cset(BROWN);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  cputs("After returning to your main ship, you  ");
  cputs("fired up your engines and headed for    ");
  cputs("home.  However, the asteroid field that ");
  cputs("caused the meteor shower lay between you");
  cputs("and your home planet.  This time you    ");
  cputs("must avoid the meteors at all cost.     ");
  cputs("Your ship has armor designed to protect ");
  cputs("you from collisions, but you will only  ");
  cputs("survive 3 hits. Also, you've figured out");
  cputs("that you can only use 1600 units of fuel");
  cputs("to maneuver past the asteroids and still");
  cputs("have enough to make it home.  Fortunatly");
  cputs("the remains of less fortunate ships can ");
  cputs("be collected and utilized for such      ");
  cputs("stratigic advantages as force reflectors");
  cputs("to bounce obstructions out of your way, ");
  cputs("repairs, or shields that protect you    ");
  cputs("from almost anything--the exceptions are");
  cputs("warp holes that take you back to the    ");
  cputs("start of the zone.");
 if (difficulty == D_EASY)
 {
  cputs(                  "  The shortest route  ");
  cputs("is blocked by a large asteroid with a   ");
  cputs("cave through it--the quickest, and      ");
  cputs("hardest route, but you decide the path! ");
 }
  cset(GREEN);
  gotoxy(1,25);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  if (getch() == ENTER)
    return;

  titlebar("game C: ASTER@IDS: The Trip Home",4, 3);
  cset(BROWN);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  gotoxy(1,5);
  cputs("Since these instructions are longer than");
  cputs("others, you can press ENTER at any time ");
  cputs("to skip them.\r\n\r\n\r\n");

  cputs("When the game starts you will be at the ");
  cputs("map screen.  There are two types of maps");
  cputs("availible to you, SCANNER, and RADAR.   ");
  cputs("The radar map should be showing now, and");
  cputs("you can switch between them by pressing ");
  cputs("the SPACEBAR at any time.  The \'u\' key  ");
  cputs("uses items on the map screen.\r\n\r\n");

  cputs("Note that there are differences between ");
  cputs("ASTER@IDS in Training difficulty and the");
  cputs("the other difficutly levels.  You will  ");
  cputs("want to read these instructions again   ");
  cputs("when you change levels.                 ");
  if (difficulty != D_EASY)
  {
    cset(YELLOW);
    cputs("The changed lines appear in yellow.     ");
  }
  cset(GREEN);
  gotoxy(1,25);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  if (getch() == ENTER)
    return;

  titlebar("game C: ASTER@IDS: The Trip Home",4, 3);
  cset(BROWN);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  cputs("the RADAR map -- The radar map itself   ");
  cputs("shows density, and therefore aproximate ");
  cputs("difficultiy of an area.  Below is a     ");
  cputs("discription of where you are and where  ");
  cputs("you are going, the apporximate          ");
  cputs("difficulty of the next course, fuel     ");
  cputs("remaining, the condition of your ship,  ");
  cputs("and any other special messages.  The    ");
  cputs("arrow keys select a zone and ENTER takes");
  cputs("you to the flight mode.  Zone selection ");
  cputs("is different then you might expect, at  ");
  cputs("any one time you are not IN a zone, but ");
  cputs("BETWEEN two zones.  The red line shows  ");
  cputs("the zone you will play when you press   ");
  cputs("ENTER and the highlighted square shows  ");
  cputs("the NEXT zone you will play.  There are ");
  cputs("usally six zones to choose from. You can");
  cputs("play the small rocks and some edges of  ");
  cputs("larger asteroids, with only one half    ");
  cputs("of the screen .  Also, the \"d\"'s        ");
  cputs("indicate an electrical disturbace which ");
  cputs("blocked the radar, objects come at you  ");
  cputs("from all directions in these.           ");
  cset(GREEN);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  if (getch() == ENTER)
    return;

  titlebar("game C: ASTER@IDS: The Trip Home",4, 3);
  cset(BROWN);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  gotoxy(1,8);
  cputs("the SCANNER map -- The scanner map shows");
  cputs("what you are most likely to encouter in ");
  cputs("that zone.  You can select any zone for ");
  cputs("a scan, and the aproximate percents of  ");
  cputs("various objects will shown at the bottom");
  cputs("of the screen along with the drifting   ");
  cputs("speed of objects in that zone.          ");
  gotoxy(1,25);
  cset(GREEN);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  if (getch() == ENTER)
    return;

  titlebar("game C: ASTER@IDS: The Trip Home",4, 3);
  cset(BROWN);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  gotoxy(1,3);
  cputs("When you enter the flight mode, the     ");
  cputs("stuff on the right side of the screen   ");
  cputs("will become more important.  At the very");
  cputs("bottom is the distance left in this     ");
  cputs("zone, just above that is the message    ");
  cputs("area.  To the left of the upper region  ");
  cputs("are the item bars.  Each meter has two  ");
  cputs("parts, each dash represents one unit,   ");
  cputs("and there are 50 dashes, when they all  ");
  cputs("disappear, a notch disappears from the  ");
  cputs("other bar.  On the Force R. bar each    ");
  cputs("dash represents current charge and the  ");
  cputs("other is the charge rate.  The remaining");
  cputs("area is the icon box for your items.    ");
  cputs("If an icons symbol is dark on black, you");
  cputs("do not currently have that item.  If it ");
  cputs("has a cyan background you have it.  If  ");
  cputs("the symbol is black, you don't have     ");
  cputs("enough power to use it.  If it is       ");
  cputs("colored, you have enough power to use it");
  gotoxy(1,25);
  cset(GREEN);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  if (getch() == ENTER)
    return;

  titlebar("game C: ASTER@IDS: The Trip Home",4, 3);
  cset(BROWN);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  gotoxy(1,5);
  cputs("While in the flight mode, the arrow keys");
  cputs("will move your ship, and SPACE will     ");
  cputs("activate your active item.              ");
  cputs("The left-hand set of bars shows what    ");
  cputs("your active item is, and how much power ");
  cputs("it has.\r\n");
  cputs("The \'v\' key will pause the game and     ");
  cputs("allow you to choose a new active item.  ");
  cputs("(press it again to return to the game.) \r\n");
  
 if (difficulty == D_EASY)
 {
  cputs("The right-hand bar shows you how many   ");
  cputs("power-ups you have collected (up to 5)  ");
  cputs("Power from this bar will automatically  ");
  cputs("be used to fill the Bonus Bar (in the   ");
  cputs("lower right corner)  If you don't like  ");
  cputs("what you got in the Bonus Bar, press \'b\'");
  cputs("to pass on that bonus.                  ");
 }
 else
 {
  cset(YELLOW);
  cputs("The right-hand bar is the item that will");
  cputs("gain extra power when you collect a     ");
  cputs("power-up. \r\n"); 
  cputs("Pressing the \'b\' key works like \'v\'     ");
  cputs("above, only for the right-hand bar.     ");
 }
  gotoxy(1,25);
  cset(GREEN);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  if (getch() == ENTER)
    return;

  titlebar("game C: ASTER@IDS: The Trip Home",4, 3);
  cset(BROWN);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  gotoxy(1,6);
  cputs("Power bar lights:\r\n");
  cputs("If the light is black, you don't have   ");
  cputs("enough power to use the item.           ");
  cputs("If it is green, you have enough power to");
  cputs("to use it.                              ");
  cputs("If it is red, you have enough power, but");
  cputs("the item can\'t be \'used\' here (map or   ");
  cputs("flight mode)                            ");
  cputs("If it is dark red/green it is off, if it");
  cputs("is light red/green, it is on and        ");
  cputs("probably consuming power.               ");
  gotoxy(1,25);
  cset(GREEN);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  if (getch() == ENTER)
    return;

  titlebar("game C: ASTER@IDS: The Trip Home",4, 3);
  cset(BROWN);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  gotoxy(1,7);
  cputs("Bonus Bar: The bar between the message  ");
  cputs("area and the distance counter is the    ");
  cputs("Bonus Bar.  As time goes by (about once ");
  cputs("an area) the bar will fill and you will ");
  cputs("get a random bonus.  To \'accept\' the    ");
  cputs("bonus, press the \'n\' key.               ");
  cputs("\"But why do I gotta press the key?\"     ");
  cputs("Well, a couple of the items (list on    ");
  cputs("next page) can be made much more        ");
  cputs("effective by using them at the right    ");
  cputs("moment.  It also gives you as much time ");
  cputs("as you need to see what you got so you  ");
  cputs("know what to do with it.                \r\n");
  
  gotoxy(1,25);
  cset(GREEN);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  if (getch() == ENTER)
    return;

  titlebar("game C: ASTER@IDS: The Trip Home",4, 3);
  cset(BROWN);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  gotoxy(1,2);
  cputs("         BONUSES\r\n");
  cputs("+<item>: Ups your power in <item> a     ");
  cputs("  little bit.                           ");
  cputs("Fuel: Gives you a little extra fuel to  ");
  cputs("  make sure you make it home.           ");
 if (difficulty == D_EASY)
 {
  cputs("Extra Spins: Effectivly gives you two   ");
  cputs("  power-ups, twice as many bonuses.     ");
 }
 else
 {
  cset(YELLOW);
  cputs("Double Power: As if you had collected   ");
  cputs("  two power-ups.                        ");
  cset(BROWN);
 }
  cputs("Force Wall: Throws up a force wall that ");
  cputs("  will bounce a few things away.        ");
  cputs("Super F(orce) R(eflecter): Bounces      ");
  cputs("  everything on the screen away from you");
  cputs("Invicible: Makes your ship completely   ");
  cputs("  invulnerable to EVERYTHING.           ");
  cputs("Repairs: Gives you the ability to       ");
  cputs("  survive one additonal hit.            ");
  cputs("Slowdown: Take the area's speed down a  ");
  cputs("  notch, making it easier for you.      ");
  cputs("Warp: Skips the rest of the current     ");
  cputs("  area, saving fuel, time and risk.     ");
  cputs("Gain Item: Gives you a new item that you");
  cputs("  can use.                              ");
  cputs("Ping: Momentarily reveals all mines.    ");
  cputs("  Appears in Stealth Mine zones only.   ");
  gotoxy(1,25);
  cset(GREEN);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  if (getch() == ENTER)
    return;

  titlebar("game C: ASTER@IDS: The Trip Home",4, 3);
  cset(BROWN);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  gotoxy(1,4);
  cputs("Some of the objects you will encouter in");
  cputs("flight mode are...\r\n\r\n\r\n");
  cputs("     YOUR SHIP.\r\n");
  cputs("     ASTEROIDS--avoid.\r\n");
  cputs("     WARP HOLES--avoid.\r\n");
  cputs("     COMET--avoid.\r\n");
  cputs("     STARS & LIGHTS--just background.   ");
  cputs("     SPACE JUNK--grab 'em.\n\r");
  cputs("     WALLS.--aim for the gaps.          ");
  cputs("     STEALTH MINES--avoid -- if you can.\r\n");
  cputs("Yes, the comets are back, you don't have");
  cputs("CEWS, but they aren't faster than       ");
  cputs("anything else.\r\n");
  cputs("When, and if, you reach the end, you    ");
  cputs("have to select the dashed section of the");
  cputs("frame to win.\r\n");
  cputs("Also, if you do run out of fuel, you can");
  cputs("still play, but won't win.              ");
  cset(GREEN);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  showanim();

 if (difficulty == D_EASY)
 {
  titlebar("game C: ASTER@IDS: The Trip Home",4, 3);
  cset(BROWN);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  cputs("You have two basic weapons availiable to");
  cputs("you at the start.  There is a chance you");
  cputs("may gain more as the game progresses.   ");
  shared.player.items[T_LASER].describeWorded(1, 6, 40, 16);
  shared.player.items[T_SHIELD].describeWorded(1, 17, 40, 24);
  gotoxy(1,25);
  cset(GREEN);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  getch();
 }
}

//shows the pictures on the instruction screen
void Asteroids::showanim(void)
{
  Sprite sprite[31];

  SpriteManager sm(0);
  sm.initialize(&shared);

  int frame=0, a;

  shared.zone.scrollx = -1;
  shared.zone.scrolly = 0;
  shared.zone.bcolor = BLACK;

  for (a = 0;a < 31;a++)
    sprite[a].initialize();

  sm.ship3(&(sprite[0]), &(sprite[1]), &(sprite[2]), 4, 8);
  for (a = 3;a < 7;a++)
  {
    sm.rock(&(sprite[a]), 0, 0);
    sprite[a].x = a-2;
    sprite[a].y = 9;
  }
  for (a = 7;a < 11;a++)
  {
    sm.warp(&(sprite[a]), 0, 0, 1, 1);
    sprite[a].x = a-6;
    sprite[a].y = 10;
  }
  sm.comet4(&(sprite[11]), &(sprite[12]), &(sprite[13]), &(sprite[14]),
            shared.zone.scrollx, shared.zone.scrolly);
  for (a = 11;a < 15;a++)
  {
    sprite[a].x = a-10;
    sprite[a].y = 11;
  }
  sm.star(&(sprite[15]));
  sm.star(&(sprite[16]));
  sm.light(&(sprite[17]), 0, 0, random(8));
  sm.light(&(sprite[18]), 0, 0, random(8));
  for (a = 15;a < 19;a++)
  {
    sprite[a].x = a-14;
    sprite[a].y = 12;
  }
  for (a = 19;a < 23;a++)
  {
    sm.powrup(&(sprite[a]), 0, 0, 1, 0, a%2 ? ST_POWER : ST_INSTANT);
    sprite[a].x = a-18;
    sprite[a].y = 13;
  }
  for (a = 23;a < 27;a++)
  {
    sm.wall(&(sprite[a]), 0, 0, DARKGRAY, 219);
    sprite[a].x = a-22;
    sprite[a].y = 14;
  }
  for (a = 27;a < 31;a++)
  {
    sm.stealth(&(sprite[a]), 0, 0);
    sprite[a].x = a-26;
    sprite[a].y = 15;
  }
  do {
    delay(150);
    if (++frame == 4) frame = 0;
    for (a = 0;a < 31;a++)
    {
      gotoxy(sprite[a].x, sprite[a].y);
      if (sprite[a].bcolor == -1)
        cset(sprite[a].scolor[frame]);
      else
        cset(sprite[a].scolor[frame], sprite[a].bcolor);

      putch(sprite[a].pic[frame]);
    }
  } while (!(getkey()));
}


// what it looks like
void Asteroids::endgameC(int planet)
{

  int frame = 0, a, b, distance = 0, snd = 100, ll, wl;

  Sprite sprite[60];
  SpriteManager sm(0);
  sm.initialize(&shared);

  for (a = 0;a < 60;a++)
    sprite[a].active = 0;

  shared.zone.scrollx = -1;
  shared.zone.scrolly = 0;
  shared.zone.maxtop = 2;
  shared.zone.maxbottom = 24;
  shared.zone.maxleft = 2;
  shared.zone.maxright = 37;

  cset(WHITE);
  clrscr();
  textbox(1, 1, 39, 25);

  sm.ship3(&(sprite[47]), &(sprite[48]), &(sprite[49]), 4, 13);
  for (a = 47;a < 60;a++)
  {
    sprite[a].dx = 1;
    sprite[a].dy = 0;
  }
  for (a = 0;a < 40;a++)
    sm.star(&(sprite[a]));

  frameControl.set(18);
  frameControl.sync();

  do {
    if (snd > 0)
      speaker.play(snd-=2);
    if (++distance == 10)
    {
      for (a = 0;a < 40;a++)
        sprite[a].dx = -1;
    }
    if (distance == 20)
    {
      for (a = 0;a < 40;a++)
      {
        for (b = 0;b < 4;b++)
          sprite[a].pic[b] = 196;
      }
    }
    if (fuel <= 0)
    {
      if (distance == 40)
        snd = 0;
      if (distance > 45 && distance < 60)
      {
        gotoxy(3, 13);
        cset(BROWN);
        cputs("Somewhere in the depths of space...");
      }
      if (distance == 60)
      {
        gotoxy(3, 13);
        cputs("                                   ");
        sprite[47].active = 1;
        sprite[47].x = 4;
        sprite[48].active = 1;
        sprite[48].x = 3;
        sprite[49].active = 1;
        sprite[49].x = 2;
      }
      if (distance == 65)
      {
        for (a = 0;a < 40;a++)
        {
          for (b = 0;b < 4;b++)
            sprite[a].pic[b] = random(2)+249;
        }
      }
      if (distance > 70 && distance < 80)
      {
          speaker.play(70);
          sm.wall(&(sprite[distance-20]), shared.zone.scrollx,
                  shared.zone.scrolly, LIGHTGRAY, random(3)+176);
          sprite[distance-20].x = sprite[49].x;
          sprite[distance-20].y = 13;
      }
      if (distance == 80)
      {
        for (a = 0;a < 40;a++)
          sprite[a].dx = 0;
        sprite[48].dx = 0;
        sprite[47].dx = 0;
        sm.wall(&(sprite[49]), shared.zone.scrollx,
                shared.zone.scrolly, LIGHTGRAY, random(3)+176);
        sprite[49].x = sprite[48].x-1;
        sprite[49].y = 13;
        snd = 0;
      }
    }
    for (a = 0;a < 40;a++)
    {
      if (random(2) == 0 && sprite[a].active == 0)
      {
        sprite[a].active = 1;
        sprite[a].x = 38;
      }
    }
    if (++frame == 4)
      frame = 0;
    for (a = 0;a < 60;a++)
    {
      if (sprite[a].active == 1)
      {
        cset(sprite[a].scolor[frame]);
        gotoxy(sprite[a].x, sprite[a].y);
        putch(' ');
        sprite[a].x += sprite[a].dx;
        sprite[a].y += sprite[a].dy;
        if (sprite[a].dx != 0
         && (sprite[a].x <= shared.zone.maxleft-1
             || sprite[a].x >= shared.zone.maxright+1))
          sprite[a].active = 0;
        else if (sprite[a].dy != 0
              && (sprite[a].y <= shared.zone.maxtop-1
                  || sprite[a].y >= shared.zone.maxbottom+1))
          sprite[a].active = 0;
        else
        {
          gotoxy(sprite[a].x, sprite[a].y);
          putch(sprite[a].pic[frame]);
        }
      }
    }
    frameControl.force();
    if (snd > 0)
      speaker.play(snd+20);
    else
      speaker.stop();
    frameControl.force();
    speaker.stop();
  } while ((distance < 100 && fuel <= 0) || (distance < 40 && fuel > 0));


  if (fuel > 0)
  {
  if (planet == 1)
  {
    ll = RED;
    wl = BROWN;
  }
  else
  {
    ll = GREEN;
    wl = BLUE;
  }
  textbox(1, 1, 39, 25);
  cset (WHITE);
  for (a = 2;a < 39;a++)
  {
    for (b = 2;b < 24;b++)
    {
      if (random(25) == 0)
      {
        gotoxy(a, b);
        putch(random(2)+249);
      }
    }
  }
  gotoxy(33, 8);
  cset(ll);
  putch(220);
  cset(ll, wl);
  putch(220);
  cset(WHITE, wl);
  putch(223);
  cset(ll, wl);
  putch(220);
  cset(ll);
  putch(220);
  cset(ll, wl);
  gotoxy(31, 9);
  dline(3, 219); putch(221); dline(2, 32); putch(219);
  cset(DARKGRAY, ll);
  putch(222);
  cset(ll, wl);
  gotoxy(31, 10);
  dline(3, 219); dline(3, 32); putch(222); putch(219);
  cset(ll);
  gotoxy(30, 11);
  putch(222);
  cset(ll, wl);
  dline(2, 219); putch(221); dline(4, 32);
  cset(DARKGRAY, ll);
  putch(222);
  cset(ll, wl);
  gotoxy(30, 12);
  dline(2, 219); putch(32); putch(222); dline(4, 32);
  cset(DARKGRAY, wl);
  putch(222);
  cset(ll, wl);
  gotoxy(30, 13);
  dline(2, 219); putch(32); putch(221); putch(32); putch(249); dline(2, 32);
  cset(BLACK);
  putch(219);
  cset(ll, wl);
  gotoxy(30, 14);
  putch(219); putch(221); putch(222); dline(4, 32);
  cset(BLACK, wl);
  putch(222);
  cset(DARKGRAY);
  putch(220);
  gotoxy(30, 15);
  cset(ll);
  putch(222);
  cset(ll, wl);
  dline(5, 32);
  cset(BLACK, wl);
  putch(220);
  cset(DARKGRAY);
  putch(222); putch(219);
  cset(BLACK, wl);
  gotoxy(31, 16);
  putch(220); putch(32); dline(2, 220);
  cset(DARKGRAY);
  dline(2, 32); dline(2, 219);
  gotoxy(31, 17);
  putch(219); dline(5, 32); dline(2, 219);
  gotoxy(33, 18);
  cset(BLACK);
  putch(223);
  cset(BLACK, LIGHTGRAY);
  putch(223); putch(32); putch(223);
  cset(DARKGRAY);
  putch(223);
  speaker.play(80);
  for (a = 2;a < 6;a++)
  {
    gotoxy(a, 7);
    if (random(3) == 0)
      b = RED;
    else b = random(2)+14;
    cset(b);
    putch(32);
    putch(219);
    cset(LIGHTGRAY);
    putch(219);
    putch(16);
    delay(150);
  }
  gotoxy(6, 7);
  dline(3, 32);
  speaker.play(70);
  for (a = 8;a < 13;a++)
  {
    gotoxy(a, 8);
    if (random(3) == 0)
      b = RED;
    else b = random(2)+14;
    cset(b);
    putch(32);
    putch(219);
    cset(LIGHTGRAY);
    putch(16);
    delay(150);
  }
  gotoxy(13, 8);
  dline(2, 32);
  speaker.stop();
  for (a = 14;a < 19;a++)
  {
    gotoxy(a, 9);
    if (random(3) == 0)
      b = RED;
    else b = random(2)+14;
    cset(b);
    putch(32);
    putch(219);
    delay(150);
  }
  gotoxy(19, 9);
  putch(32);
  for (a = 19;a < 23;a++)
  {
    gotoxy(a, 10);
    if (random(3) == 0)
      b = RED;
    else b = random(2)+14;
    cset(b);
    putch(32);
    putch(254);
    delay(150);
  }
  gotoxy(23, 10);
  putch(32);
  for (a = 23;a < 25;a++);
  {
    gotoxy(a, 11);
    cset(RED);
    putch(32);
    putch(249);
    delay(150);
  }
  gotoxy(26, 11);
  putch(32);
  gotoxy(27, 12);
  putch(250);
  delay(150);
  gotoxy(27, 12);
  putch(32);
  putch(250);
  delay(150);
  gotoxy(28, 12);
  putch(32);
  cset(WHITE);
  for (a = 0;a < 50;a++)
  {
    gotoxy(29, 13);
    switch (a%4)
    {
      case 0: putch(196); break;
      case 1: putch(47); break;
      case 2: putch(179); break;
      case 3: putch(92); break;
    }
    delay(20);
  }
  gotoxy(29, 13);
  putch(32);
  }

}

