// buffer.cpp

#include <conio.h>
#include "buffer.h"

Buffer::~Buffer(void)
{
  if (bitmap)
    delete[] bitmap;
}

void Buffer::initialize(int h, int w, int ox, int oy)
{
  if (bitmap)
    delete[] bitmap;

  height = h;
  width = w;
  offX = ox;
  offY = oy;

  bitmap = new char [height*width];

  if (!bitmap)
  {
    cputs("unable to create safe bitmap");
    getch();
  }

  clear();
}

void Buffer::safeErase(int x, int y, int color)
{
  if (x-offX < 0 || x-offX > width || y-offY < 0 || y-offY >= height)
    return;

  if ( !bitmap || (bitmap && bitmap[ (y-offY) * width + (x-offX) ] == 0) )
  {
    gotoxy(x, y);
    textbackground(color);
    putch(' ');
  }
}

void Buffer::safeDraw(int x, int y, char what, int fcolor, int bcolor)
{
  if (x-offX < 0 || x-offX >= width || y-offY < 0 || y-offY >= height)
    return;

  gotoxy(x, y);
  textcolor(fcolor);
  textbackground(bcolor);
  putch(what);

  bitmap[ (y-offY) * width + (x-offX) ] = 1;
}

void Buffer::clear(void)
{
  char *b = bitmap;
  int a = width*height;

  while (a-- > 0)
    *(b++) = 0;
}
