// safer buffering

#ifndef BUFFER_H
#define BUFFER_H

#include <stddef.h>

class Buffer
{
public:
  Buffer(void)
    : bitmap(NULL), height(0), width(0)
  {}
  Buffer(int h, int w, int ox, int oy)
    : bitmap(NULL)
  { initialize(h, w, ox, oy); }
  ~Buffer(void);

  void initialize(int h, int w, int ox, int oy);

  void safeErase(int x, int y, int color);
  void safeDraw(int x, int y, char what, int fcolor, int bcolor);

  void clear(void);

protected:
  char *bitmap;
  int height, width;
  int offX, offY;
};

#endif
