#ifndef CONST_H
#define CONST_H

#include "ascii.h" // ascii pic constants
//#define CHEAT
// used to disable the cheat codes

enum spritetype {ST_SHIPNOSE, ST_SHIPBODY, ST_SHIPFIRE,
  ST_STAR, ST_LIGHT,
  ST_COMET, ST_CTAIL1, ST_CTAIL2, ST_CTAIL3,
  ST_METEOR, ST_WARP, ST_POWER, ST_INSTANT, ST_WALL, ST_MINE,
  ST_LASER, ST_BOSSLASER, ST_BOSSBLOCK,
  ST_EXPLODE, ST_BOMB, ST_PCUT, ST_SPECIAL,
  NUMSPRITETYPE};

enum reacttype {RA_NONE = 0, RA_BOUNCEHIT = 1, RA_HARDHIT = 2, RA_FORCER = 4,
  RA_WARP = 5, RA_BOSS = 6, RA_POWER = 10};

enum activetype {ACT_RELEASED = -2, ACT_SLAVE = -1, ACT_DEAD = 0,
                 ACT_ALIVE = 1, ACT_DYING = 2, ACT_RESERVED = 3};

enum drawpriority {DP_BACKGROUND, DP_POWER, DP_NORMAL, DP_IMPORTANT};

enum wallzonetype {WT_RANDOM, WT_TUNNEL};

const NUMHOLES = 2;

const int MAPXSIZE = 20, MAPYSIZE = 10;

enum zone_type {Z_EMPTY = 0, Z_SLOWROCK = 1, Z_MEDROCK = 2, Z_FASTROCK = 3,
  Z_SLOWCOMET = 4, Z_MEDCOMET = 5, Z_FASTCOMET = 6,
  Z_SLOWWARP = 7, Z_MEDWARP = 8, Z_FASTWARP = 9,
  Z_SLOWWALL = 10, Z_MEDWALL = 11, Z_FASTWALL = 12,
  Z_SLOWMINE = 13, Z_MEDMINE = 14, Z_FASTMINE = 15,
  Z_DISTROCK = 16, Z_DISTWARP = 17, Z_DISTCOMET = 18,
  Z_TOP = 19, Z_RIGHT = 20, Z_LEFT = 21, Z_BOTTOM = 22,
  Z_SLOWHUNK = 23, Z_MEDHUNK = 24, Z_FASTHUNK = 25,
  Z_SOLID = 26, Z_BOSS = 27, Z_SECRET = 28, NUMZONES = 29};

enum char_pics {P_BOTTOM = 220, P_LEFT = 221, P_RIGHT = 222, P_TOP = 223,
  P_LIGHT = 176, P_MEDIUM = 177, P_DENSE = 178,
  P_TRIPHBAR = 240, P_WARP = 21,
  P_SINGVBAR = 179, P_DOUBVBAR = 186,
  P_DIAMOND = 4, P_BIGDOT = 249,
  P_SMSQUARE = 254, P_BIGSQUARE = 219,
  P_UPARROW = 24};

enum trinkets {T_NONE = 0,
  T_FUEL, T_SLOWDOWN,
  T_GAINITEM,
  T_HITS,
  T_SHIELD, T_LASER, T_SUPERFR, T_PHASE, 
  T_RADAR, T_RANDSQ, T_CHOOSESQ, T_PING,
  T_BOMBARD, T_SEED, 
  T_WARP, T_RANDOM,
  NUMTRINKETS = 17};

enum playmode {PM_CLASSIC, PM_NEW};

enum canusetype {CU_CANT = 0x00, CU_OWNED = 0x01, CU_MAP = 0x02,
                 CU_FLIGHT = 0x04};

enum dirtyType {ALITTLE = 1, ALOT = 2};

// xpositions of the bars.
const int LEFTBAR = 27, RIGHTBAR = 29;
const int MAXEXP = 600;
const int EXPBARSIZE = 13;

// keys
const int RIGHT = 177;
const int LEFT = 175;
const int UP = 172;
const int DOWN = 180;
const int SPACE = 32;
const int ESCAPE = 27;
const int ENTER = 13;
const int F1 = 159;
const int F2 = 160;
const int F3 = 161;
const int F4 = 162;
const int F5 = 163;

enum diffconst {D_EASY, D_MEDIUM, D_HARD, D_RIDICULOUS};

#endif
