// the DODGEBEAM game and related fucntions
#ifndef DB_H
#define DB_H

const int MAXBARRIER = 10;
const int MAXPRIZE = 1;
const int NUMSTUFF = MAXBARRIER + MAXPRIZE + 1;
const int NUMLASER = 10;

class DBItem
{
public:
  DBItem(void)
    : what(0), x(5), y(1), pic(0), color(BLACK),
    active(0), drawnX(1), drawnY(1), drawn(0), changed(1)
    {}

  void set(int w, int ypos, char p, int c);
  int isWhat(void)
    {return what;}
  int isActive(void)
    {return active;}
  void kill(int autoErase = 1)
    {if (drawn && autoErase) erase(); active = 0;}
  int getY(void)
    {return y;}
  int getX(void)
    {return x;}
  void setY(int toWhat)
    {if (y != toWhat) changed = 1; y = toWhat;}
  void setX(int toWhat)
    {if (x != toWhat) changed = 1; x = toWhat;}
  void refresh(void)
    {changed = 1;}

  void draw(void);
  void erase(void);
  void move(void);

protected:
  int active, what, x, y, color;
  int drawnX, drawnY, drawn, changed;
  char pic;
};

class DodgeBeam
{
public:
  DodgeBeam(void)
    : lives(0), gamestat(0), laserSound(1)
    {}
  void initialize(void);

  int game(void);
  void endSequence(void);
  int getLives(void)
    {return lives;}
  void toggleLaserSound(void)
    {laserSound = !laserSound;}
  int getLaserSound(void)
    {return laserSound;}
  void instructions(void);

protected:
  void drawFrame(void);

  void updateBat(int erase = 1);
  void drawCannons(void);
  void destroyBarriers(void);
  void fireLaser(void);
  void shuffle(void);
  void shuffleCannons(void);
  void loseLife(void);
  void setDifficulty(void);

  void drawEndCannon(int cy, int cx = 38);

  int lives;
  int gamestat;
  int laserSound;

  DBItem stuff[NUMSTUFF];
  int laser[NUMLASER], lasernum;
  int frameRate, totalbar;

  int battery, maxBattery;

  int pull;
  int death;
  int laserColor, length, laserY, status, shuffleTime;
};

#endif
