// password manager

#include <string.h>
#include <stdlib.h>
#include <conio.h>
#include "escpass.h"
#include "const.h" // for CHEAT

void Password::initialize(WORD k, char *pw)
{
  clean();

  key = k;

  if (pw == NULL)
    produceFromKey();
  else
  {
    password = new char(strlen(pw)+1);
    if (password != NULL)
      strcpy(password, pw);
  }
}

void Password::clean(void)
{
  if (password != NULL)
  {
    delete password;
    password = NULL;
  }
}

WORD Password::check(char *pw)
{
  if (strcmp(pw, password) == 0)
    return key;
  else
    return 0;
}

void Password::produceFromKey(void)
{
  clean();
  srand(key);

  int length = random(4)+4;
  char blah;

  password = new char [length+1];
  if (password == NULL)
    return;
  password[length] = '\0';

  for (int a = 0;a < length;a++)
  {
    switch(random(3))
    {
      case 0: blah = '0' + random(10); break;
      case 1: blah = 'a' + random(26); break;
      case 2: blah = 'A' + random(26); break;
      default:
        cputs("oops");
	getch();
	break;
    }
    password[a] = blah;
  }

  randomize();
}

void PasswordManager::initialize(int n)
{
  number = n;

  clean();

  passwords = new Password* [number];
  if (passwords == NULL)
  {
    clean();
    return;
  }
  else
  {
    for (int a = 0;a < number;a++)
      passwords[a] = NULL;
  }
}

void PasswordManager::clean(void)
{
  if (passwords != NULL)
  {
    delete passwords;
    passwords = NULL;
  }
}

void PasswordManager::add(Password *pw)
{
  if (!passwords)
    return;

  int n;
  for (n = 0;n < number;n++)
    if (passwords[n] == NULL)
      break;

  if (passwords[n] !=NULL)
    return;

  passwords[n] = pw;
}
  
void PasswordManager::remove(char *pw)
{
  int index = findByPassword(pw);
  if (index != -1)
    passwords[index] = NULL;
}

WORD PasswordManager::check(char *pw)
{
 #ifdef CHEAT
  if (strcmp(pw, "passlist") == 0)
  {
    list();
    getch();
    return 0;
  }
 #endif

  int index = findByPassword(pw);
  if (index != -1)
    return passwords[index]->getKey();
  else
    return 0;
}

char* PasswordManager::retrieveByKey(WORD key)
{
  int index = findByKey(key);
  if (index != -1)
    return passwords[index]->getPassword();
  else
    return "";
}
// protected

int PasswordManager::findByPassword(char *pw)
{
  for (int n = 0;n < number;n++)
    if (passwords[n] != NULL && passwords[n]->check(pw) != 0)
      return n;
  return -1;
}

int PasswordManager::findByKey(WORD key)
{
  for (int n = 0;n < number;n++)
    if (passwords[n] != NULL && passwords[n]->getKey() == key)
      return n;
  return -1;
}  

void PasswordManager::list(void)
{
  for (int n = 0;n < number;n++)
    if (passwords[n] != NULL)
      cprintf("\r\n%s", passwords[n]->getPassword());
}
