// password manager.

#define WORD int

class Password
{
  friend class PasswordManager;

public:
  Password(WORD k = 0, char *pw = NULL)
   : password(NULL), key(0)
  {initialize(k, pw);}
  ~Password(void)
    {clean();}

  void initialize(WORD k, char *pw = NULL);
  void clean(void);

  WORD check(char *pw);

protected:
  char* getPassword(void)
    {return password;}
  WORD getKey(void)
    {return key;}

  void produceFromKey(void);

  char* password;
  WORD key;
};

class PasswordManager
{
public:
  PasswordManager(int n = 1)
    : passwords(NULL), number(n)
  {initialize(n);}
  ~PasswordManager(void)
    {clean();}

  void initialize(int n);
  void clean(void);
    
  void add(Password *pw);
  void remove(char *pw);
  WORD check(char *pw);
  char* retrieveByKey(WORD key);

protected:
  int findByPassword(char *pw);
  int findByKey(WORD key);
  void list(void);

  Password **passwords;
  int number;
};

