// general functions for games

#include "gamefunc.h"

diffconst difficulty;

FrameControl frameControl;
Sound speaker;

// assigns both forground and background at once
void cset(int forg, int backg)
{
  textcolor(forg);
  textbackground(backg);
}

// returns arrow key
int getkey(void)
{
  int keyin = 0;
  if (kbhit())
  {
    keyin = getch();
    if (keyin == 0) keyin = getch() + 100;
  }
  switch(keyin)
  {
    case F1:
      if (speaker.isOn())
        speaker.mute();
      else
        speaker.on();
      break;
/*
    case F3:
      frameControl.setVisible(!frameControl.getVisible());
      break;
    case F4:
      frameControl.set(frameControl.get() + 1);
      break;
    case F5:
      frameControl.set(frameControl.get() - 1);
      break;
*/
   }
  return keyin;
}

//text "typeing"
int type(unsigned char print[46], int stop)
{
  int a, ret = 0;
  for (a = 0;a < 45;a++)
  {
    if (print[a] == '#')
      print[a] = (unsigned char)240;
    putch(print[a]);
    delay(25);
    if (print[a] != ' ')
      speaker.play(100);
    delay(25);
    speaker.stop();
    if (print[a+1] == '\0')
      a = 45;
    if (stop == 1 && getkey() != 0)
      a = 50;
  }
  if (a > 48)
    ret = 1;
  return ret;
}

//grabs an entire string
int getstr(char tarptr[], int strsize, unsigned char fill)
{
  if (tarptr == NULL)
    return 0;

  int a, index = 0;
  do {
    a = getch();
    if (a == 8)
    {
      if (index < 1)
      {
        speaker.playFor(50, 100);
	continue;
      }
      gotoxy(wherex()-1, wherey());
      putch(32);
      gotoxy(wherex()-1, wherey());
      index--;
    }
    else if (a == 13)
      ;
    else if (index < strsize-1)
    {
      if (a != 13)
        tarptr[index++] = (unsigned char)a;

      if (fill == 0)
        putch(a);
      else
        putch(fill);
    }
    else
    {
      sound(50);
      delay(100);
      nosound();
    }
  } while (a != 13);
  tarptr[index] = '\x0';
  return index;
}


//returns if a number is 1, -1, or 0
int sign(int evalnum)
{
  int returnnum;
  if (evalnum == 0) returnnum = 0;
  else if (evalnum > 0) returnnum = 1;
  else if (evalnum < 0) returnnum = -1;
  return returnnum;
}

// intermintent beeping
void beepbeep(int freq, int dlay, int numloop)
{
  for (int a = 0; a < numloop;a++)
  {
    if (a % 2 == 0) speaker.play(freq);
    delay(dlay);
    speaker.stop();
  }
}

//create a box with text characters
void textbox(int left, int top, int right, int bottom,
        int colbak, int colbor, int singdoub, int grid)
{
  int ul, ur, ll, lr, vert, horiz, jl, jr, jb, sizex, sizey, a, b;
  struct text_info ti;
  gettextinfo(&ti);

  cset(colbor, colbak);

  if (singdoub == 1)
  {
    ul = 218;
    ur = 191;
    ll = 192;
    lr = 217;
    vert = 179;
    horiz = 196;
    jl = 195;
    jr = 180;
    jb = 193;
  }
  else
  {
    ul = 201;
    ur = 187;
    ll = 200;
    lr = 188;
    vert = 186;
    horiz = 205;
    jl = 199;
    jr = 182;
    jb = 207;
  }
  sizex = right - left - 1;
  sizey = bottom - top - 1;
  gotoxy(left, top);
  putch(ul);
  dline(sizex, horiz);
  putch(ur);
  if (grid == 0)
  {
    for (a = top+1;a < top+1+sizey;a++)
    {
      gotoxy(left, a);
      putch(vert);
      dline(sizex, 32);
      putch(vert);
    }
    gotoxy(left, bottom);
    putch(ll);
    dline(sizex, horiz);
    putch(lr);
  }
  else
  {
    sizey-=2;
    gotoxy(left, top+1);
    putch(vert);
    dline(sizex, 32);
    putch(vert);
    gotoxy(left, top+2);
    putch(jl);
    dline((sizex-2)/3, 196);
    putch(194);
    dline((sizex-2)/3, 196);
    putch(194);
    dline((sizex-2)/3, 196);
    putch(jr);
    for (a = top+3;a < top+3+((sizey-2)/3)+2;a+=(sizey-2)/3+1)
    {
      for (b = a;b < (a+((sizey-2)/3));b++)
      {
        gotoxy(left, b);
        putch(vert);
        dline((sizex-2)/3, 32);
        putch(179);
        dline((sizex-2)/3, 32);
        putch(179);
        dline((sizex-2)/3, 32);
        putch(vert);
      }
      gotoxy(left, a+(sizey-2)/3);
      putch(jl);
      dline((sizex-2)/3, 196);
      putch(197);
      dline((sizex-2)/3, 196);
      putch(197);
      dline((sizex-2)/3, 196);
      putch(jr);
    }
    for (b = a;b < (a+((sizey-2)/3));b++)
    {
      gotoxy(left, b);
      putch(vert);
      dline((sizex-2)/3, 32);
      putch(179);
      dline((sizex-2)/3, 32);
      putch(179);
      dline((sizex-2)/3, 32);
      putch(vert);
    }
    gotoxy(left, bottom);
    putch(ll);
    dline((sizex-2)/3, horiz);
    putch(jb);
    dline((sizex-2)/3, horiz);
    putch(jb);
    dline((sizex-2)/3, horiz);
    putch(lr);
  }
  textattr(ti.attribute);
}

//draws a string of characters;
void dline(int length, int type)
{
  for (int a = 0;a < length;a++) putch(type);
}

// draws a status bar
void drawBar(int x, int y, int length, long int value, long int max,
            int fg, int bg, int howMuch)
{
  const int STEPSIZE = max / length;
  struct text_info ti;
  gettextinfo(&ti);

  if (value > max)
    value = max;
  if (value < 0)
    value = 0;

  int solid = value / STEPSIZE;
  if (solid > length)
    solid = length;  //sanity check for STEPSIZEs with remainders
  long int remainder = value % STEPSIZE; 
  remainder = remainder * ASC_FILLSTAGE / STEPSIZE;
  // remainder needs to be long; as int remainder * ASC_FILLSTAGE >? MAXINT
  if (remainder >= ASC_FILLSTAGE)
    remainder = ASC_FILLSTAGE - 1;
  if (remainder < 0)
    remainder = 0; // sanity check for really large numbers

  cset (fg, bg);

  if (howMuch >= ALOT)
  {
    gotoxy(x, y);
    for (int a = 0;a < solid;a++)
      putch(ASC_SOLID);
  }
  else
    gotoxy(x+solid, y);

  if (solid < length)
    putch(ASC_FILL[remainder]);

  if (howMuch >= ALOT)
  {
    for (int a = solid+1;a < length;a++)
      putch(' ');
  }
  textattr(ti.attribute);
}

void interruptWait(int howMuch)
{
  for (int a = 0;a < howMuch;a+=10)
  {
    if (kbhit())
      break;
    delay(10);
  }
}

void FrameControl::set(int fr)
{
  if (fr >= 0)
  {
    if (fr != frameRate)
      changed = 1;
    frameRate = fr;
    targetDelay = 1000/fr;
    frameAdj = 0;
  }
}

void FrameControl::force(void)
{
  frames++;
  int theDelay = targetDelay - work;
  if (theDelay > 0)
    delay(theDelay);
  else if (theDelay < -10) // sanity check for exceeding capabilities
  {
    frameAdj--;
    frameRate--;
    targetDelay = 1000/frameRate;
    work -= work/5;
  }
  if (frameAdj < 0 && theDelay > 10) // put it back if OK
  {
    frameAdj++;
    frameRate++;
    targetDelay = 1000/frameRate;
    work += work/5;
  }

  if (time(NULL) > currentSec)
  {
    if (changed)
      changed = 0;
    else
    {      
      // the total time per frame, work + delay adjustment
      int timePerFrame;
      if (frames == 0)
      {
        cputs("bleh frames");
        getch();
        timePerFrame = 1000;
      }
      else
        timePerFrame = 1000/frames;
      
      // get the time used for work
      work += sign(timePerFrame - targetDelay);
    }

    frames = 0;
    time(&currentSec);
  }
  if (show)
  {
    gotoxy(1,1);
    cset(WHITE);
    cprintf("F%d W%d T%d D%d A%d    ", 
      frameRate, work, targetDelay, theDelay, frameAdj);
  }
}

void FrameControl::sync(void)
{
  frames = 0;
  time(&currentSec);
  while (time(NULL) <= currentSec)
    ;
  time(&currentSec);
}

void Sound::play(int freq)
{
  if (soundOn)
    sound(freq);
}

void Sound::stop(void)
{
  nosound();
}

void Sound::playFor(int freq, int duration)
{
  if (soundOn)
    sound(freq);
  delay(duration);
  if (soundOn)
    nosound();
}
