// general functions for games
#ifndef GAMEFUNC_H
#define GAMEFUNC_H

#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <time.h>
#include "const.h"

extern diffconst difficulty;

void cset(int forg, int backg = 0);
int getkey(void);
int type(unsigned char print[46], int stop = 0);
int getstr(char tarptr[], int strsize = 81, unsigned char fill = 0);
int sign(int evalnum);
void beepbeep(int freq, int dlay, int loopnum);
void dline(int length, int type);
void drawBar(int x, int y, int length, long int value, long int max,
            int fg, int bg, int howMuch);
void interruptWait(int howMuch);
void textbox(int left, int top, int right, int bottom,
        int colbak = 0, int colbor = 1, int singdoub = 2, int grid = 0);

class FrameControl
{
public:
  FrameControl(int fr = 18)
    : frameRate(fr), work(0), targetDelay(1000/fr), frames(0),
    changed(0), show(0), frameAdj(0)
    {}

  void set(int fr);
  int get(void)
    {return frameRate;}

  void force(void);
  void sync(void);

  void setVisible(int toWhat = 1)
    {show = toWhat;}
  int getVisible(void)
    {return show;}

private:
  int frameRate, frameAdj, work, targetDelay, frames, changed, show;
  time_t currentSec;
};

extern FrameControl frameControl;

class Sound
{
public:
  Sound(void) : soundOn(1)
    {}

  void mute(void)
    {soundOn = 0;}
  void on(void)
    {soundOn = 1;}
  int isOn(void)
    {return soundOn;}

  inline void play(int freq);
  inline void stop(void);
  inline void playFor(int freq, int duration);

protected:
  int soundOn;
};

extern Sound speaker;

#endif
