// these functions were needed in the game and the map making program
// also, the functions for the ending's city pic & openings room pic
#include <stdio.h>
#include "gamefunc.h"
#include "mapfunc.h"

void saveMap(int (*z2)[MAPXSIZE][MAPYSIZE])
{
  FILE * outfile;

  if ((outfile = fopen("escape.dat","wb")) == NULL)
  {
     perror("\nOpen failed! ");
     return;
  }
  for (int a = 0;a < MAPXSIZE;a++)
    fwrite((*z2)[a], sizeof(int), MAPYSIZE, outfile);
  fclose(outfile);
}

void loadMap(int (*z2)[MAPXSIZE][MAPYSIZE])
{
  FILE * infile;

  if ((infile = fopen("escape.dat","rb")) == NULL)
  {
    perror("\nOpen failed! ");
    return;
  }
  for (int a = 0;a < MAPXSIZE;a++)
    fread((*z2)[a], sizeof(int), MAPYSIZE, infile);
  fclose(infile);
}

//frame for map screen
void drawframe(void)
{
  int a;

  textbox(1,1,25,25);
  textbox(3,3,24,14, BLACK, BLUE, 1);
  gotoxy(2,2);
  cset(BLUE);
  putch(218);
  putch(191);
  cset(WHITE);
  for (a = 65;a < 85;a++) putch(a);
  cset(BLUE);
  putch(218);
  putch(182);
  gotoxy(2,3);
  putch(192);
  putch(197);
  gotoxy(24,3);
  putch(197);
  putch(182);
  cset(WHITE);
  for (a = 0;a < 10;a++)
  {
    gotoxy(2,a+4);
    putch(a+48);
  }
  cset(BLUE);
  gotoxy(3,9);
  putch(216);
  gotoxy(24, 9);
  putch(216);
  gotoxy(2, 14);
  putch(218);
  putch(197);
  gotoxy(24, 14);
  putch(197);
  putch(182);
  gotoxy(2, 15);
  putch(192);
  putch(217);
  gotoxy(24,15);
  putch(192);
  putch(182);
  gotoxy(7, 15);
  cset(GREEN);
  cputs("SCANNER  ");
  cset(BLACK, GREEN);
  cputs("RADAR");
}

//decides on the chacter for radar screen
int switchradar(int type)
{
  int ret;
  switch(type)
  {
    case Z_EMPTY: ret = (int)' '; break;
    case Z_SLOWROCK:
    case Z_SLOWCOMET:
    case Z_SLOWWARP:
    case Z_SLOWWALL:
    case Z_SLOWMINE: ret = P_LIGHT; break;
    case Z_MEDROCK:
    case Z_MEDCOMET:
    case Z_MEDWARP:
    case Z_MEDWALL:
    case Z_MEDMINE: ret = P_MEDIUM; break;
    case Z_FASTROCK:
    case Z_FASTCOMET:
    case Z_FASTWARP:
    case Z_FASTWALL:
    case Z_FASTMINE: ret = P_DENSE; break;
    case Z_DISTROCK:
    case Z_DISTWARP:
    case Z_DISTCOMET: ret = (int)'d'; break;
    case Z_TOP: ret = P_BOTTOM; break;
    case Z_RIGHT: ret = P_LEFT; break;
    case Z_LEFT: ret = P_RIGHT; break;
    case Z_BOTTOM: ret = P_TOP; break;
    case Z_SLOWHUNK:
    case Z_MEDHUNK:
    case Z_FASTHUNK: ret = P_SMSQUARE; break;
    case Z_SOLID:
    case Z_SECRET: ret = P_BIGSQUARE; break;
    case Z_BOSS: ret = P_SINGVBAR; break;
    default: ret = P_BIGDOT; break;
  }
  return ret;
}

  // zone is 0 if empty, 1-3 if asteroids, 4-6 if comets, 7-9 if warps
  // 10-12 if walls, 13-15 if stealth mines, 16-18 if electrostatic,
  // 19-22 if halfs(=3), 23-25 if small rocks,
  // 26 if solid, 27 if the boss, and 28 if a secret zone
//decides on the chacter for scanner screen
int switchscanner(int type, int &pic)
{
  int ret = BROWN;
  switch(type)
  {
    case Z_EMPTY: pic = P_LIGHT; ret = WHITE; break;
    case Z_SLOWROCK:
    case Z_MEDROCK:
    case Z_FASTROCK: pic = (int)'@'; ret = RED; break;
    case Z_SLOWCOMET:
    case Z_MEDCOMET:
    case Z_FASTCOMET: pic = P_TRIPHBAR; ret = WHITE; break;
    case Z_SLOWWARP:
    case Z_MEDWARP:
    case Z_FASTWARP: pic = P_WARP; ret = LIGHTMAGENTA; break;
    case Z_SLOWWALL:
    case Z_MEDWALL:
    case Z_FASTWALL: pic = P_DOUBVBAR; ret = LIGHTGRAY; break;
    case Z_SLOWMINE:
    case Z_MEDMINE:
    case Z_FASTMINE: pic = P_DIAMOND; ret = LIGHTGRAY; break;
    case Z_DISTROCK: pic = (int)'@'; ret = YELLOW; break;
    case Z_DISTWARP: pic = P_WARP; ret = YELLOW; break;
    case Z_DISTCOMET: pic = P_TRIPHBAR; ret = YELLOW; break;
    case Z_TOP: pic = P_BOTTOM; break;
    case Z_RIGHT: pic = P_LEFT; break;
    case Z_LEFT: pic = P_RIGHT; break;
    case Z_BOTTOM: pic = P_TOP; break;
    case Z_SLOWHUNK:
    case Z_MEDHUNK:
    case Z_FASTHUNK: pic = P_SMSQUARE; break;
    case Z_SOLID:
    case Z_SECRET: pic = P_BIGSQUARE; break;
    case Z_BOSS: pic = (int)'?'; ret = BLUE; break;
    default: pic = (int)'?'; ret = DARKGRAY; break;
  }
  return ret;
}

void csave(int (*c2)[38][22], char name[17])
{
  FILE * outfile;

  if ((outfile = fopen(name,"wb")) == NULL)
  {
     perror("\nOpen failed! ");
     return;
  }
  for (int a = 0;a < 38;a++)
    fwrite((*c2)[a], sizeof(int), 22, outfile);
  fclose(outfile);
}

void cload(int (*c2)[38][22], char name[17])
{
  FILE * infile;

  if ((infile = fopen(name,"rb")) == NULL)
  {
    perror("\nOpen failed! ");
    return;
  }
  for (int a = 0;a < 38;a++)
    fread((*c2)[a], sizeof(int), 22, infile);
  fclose(infile);
}

  //black to dkgray to ltgray = 0-8, brown on red = 9-11,
  //red on dkgray = 12-14, brown on dkgray = 15-17,
  //flashing on dkgray = 18-23
void switchcity(int type, int fc[6])
{
  switch (type)
  {
    case 0: cset(DARKGRAY); putch(32); break;
    case 1: cset(DARKGRAY); putch(176); break;
    case 2: cset(DARKGRAY); putch(177); break;
    case 3: cset(DARKGRAY); putch(178); break;
    case 4: cset(DARKGRAY, LIGHTGRAY); putch(219); break;
    case 5: cset(DARKGRAY, LIGHTGRAY); putch(178); break;
    case 6: cset(DARKGRAY, LIGHTGRAY); putch(177); break;
    case 7: cset(DARKGRAY, LIGHTGRAY); putch(176); break;
    case 8: cset(DARKGRAY, LIGHTGRAY); putch(32); break;
    case 9: cset(RED, BROWN); putch(176); break;
    case 10: cset(RED, BROWN); putch(177); break;
    case 11: cset(RED, BROWN); putch(178); break;
    case 12: cset(DARKGRAY, RED); putch(178); break;
    case 13: cset(DARKGRAY, RED); putch(177); break;
    case 14: cset(DARKGRAY, RED); putch(176); break;
    case 15: cset(DARKGRAY, BROWN); putch(178); break;
    case 16: cset(DARKGRAY, BROWN); putch(177); break;
    case 17: cset(DARKGRAY, BROWN); putch(176); break;
    case 18: cset(fc[0], LIGHTGRAY); putch(176); break;
    case 19: cset(fc[1], LIGHTGRAY); putch(177); break;
    case 20: cset(fc[2], LIGHTGRAY); putch(178); break;
    case 21: cset(fc[3], LIGHTGRAY); putch(176); break;
    case 22: cset(fc[4], LIGHTGRAY); putch(177); break;
    case 23: cset(fc[5], LIGHTGRAY); putch(178); break;
    case 24: cset(WHITE); putch(random(2)+249); break;
    case 25: cset(WHITE); putch(219); break;
  }
}

void makeMap(void)
{
  int z[MAPXSIZE][MAPYSIZE], x = 0, y = 0, pic = 32, col = GREEN, screen = 1;
  int piece = Z_EMPTY, selectMode = 0, gamestat = 0, a, b;
  char descriptions[NUMZONES][24] = {
        {"empty space, d0       "},
        {"asteroids, d1         "},
        {"asteroids, d2         "},
        {"asteroids, d3         "},
        {"comets, d1            "},
        {"comets, d2            "},
        {"comets, d3            "},
        {"warps, d1             "},
        {"warps, d2             "},
        {"warps, d3             "},
        {"walls, d1             "},
        {"walls, d2             "},
        {"walls, d3             "},
        {"stealth mines, d1     "},
        {"stealth mines, d2     "},
        {"stealth mines, d3     "},
        {"scater, asteroids, d2 "},
        {"scater, comets, d2    "},
        {"scater, warps, d2     "},
        {"upper half only, d3   "},
        {"right half only, d3   "},
        {"left half only, d3    "},
        {"lower half only, d3   "},
        {"variable half only, d1"},
        {"variable half only, d2"},
        {"variable half only, d3"},
        {"solid                 "},
        {"boss, d4              "},
        {"secret area, d0       "} };
                               

  drawframe();
  cset(GREEN);
  for (a = 0;a < MAPXSIZE;a++)
  {
    for (b = 0;b < MAPYSIZE;b++)
    {
      gotoxy(a+4,b+4);
      z[a][b] = 0;
      putch(32);
    }
  }

  frameControl.set(18);
  frameControl.sync();

  do
  {
    switch (getkey())
    {
      case UP:
        if (selectMode)
          piece = (--piece + NUMZONES) % NUMZONES;
        else if (y > 0)
          y--;
        break;
      case DOWN:
        if (selectMode)
          piece = ++piece % NUMZONES;
        else if (y < 9)
          y++;
        break;
      case LEFT:
        if (selectMode)
          piece = (piece - 5 + NUMZONES) % NUMZONES;
        else if (x > 0)
          x--;
        break;
      case RIGHT:
        if (selectMode)
          piece = (piece + 5) % NUMZONES;
        else if (x < 19)
          x++;
        break;
      case ENTER:
       selectMode = ++selectMode % 2;
       break;
      case SPACE: z[x][y] = piece; break;
      case ESCAPE:
        gamestat = 1; break;
        case (int)'l': gotoxy(2,18);
        cputs("load?");
        if (getch() == (int)'y')
          loadMap(&z);
        break;
      case (int)'s':
        gotoxy(2, 18);
        cputs("save?");
        if (getch() == (int)'y')
          saveMap(&z);
        break;
      case (int)'t':
        if (screen == 0)
          screen = 1;
        else
          screen = 0;
      case (int)'r':
        for (a = 0;a < MAPXSIZE;a++)
        {
          for (b = 0;b < MAPYSIZE;b++)
          {
            gotoxy(a+4,b+4);
            if (screen == 0)
              col = switchscanner(z[a][b], pic);
            else
            {
              pic = switchradar(z[a][b]);
              col = GREEN;
            }
            cset(col);
            putch(pic);
          }
        }
        break;
      }
      frameControl.force();
      cset(WHITE);
      gotoxy(x+4, y+4);
      putch(219);
      frameControl.force();
      gotoxy(x+4, y+4);
      if (screen == 0)
        col = switchscanner(z[x][y], pic);
      else
      {
        pic = switchradar(z[x][y]);
        col = GREEN;
      }
      cset(col);
      putch(pic);
      gotoxy(2,17);
      cputs(descriptions[ z[x][y] ]);
      for (a = -2;a <= 2;a++)
      {
        if (a == 0)
          cset(WHITE);
        else
          cset(LIGHTGRAY);
        gotoxy(2, 21+a);
        cputs(descriptions[ (piece + NUMZONES + a) % NUMZONES ]);
      }

  } while (gamestat == 0);
}

void randomMap(int (&z)[MAPXSIZE][MAPYSIZE])
{
  int hf[MAPXSIZE][MAPYSIZE], ztype[MAPXSIZE][MAPYSIZE];

  heightField(hf, random(2));
  reduceHeightField(hf);

  if (findShortestPath(hf) > 61)
    makeTunnel(hf);
  else
  {
    hf[19][4] = Z_TOP;
    hf[19][5] = Z_BOSS;
    hf[19][6] = Z_BOTTOM;

    // make sure we didn't just block off the shortest path.
    if (findShortestPath(hf) > 61)
      makeTunnel(hf);
  }

  hunksToEdges(hf);
  chooseZoneType(ztype);
  // merge
  mergeZones(hf, ztype);
  copyMap(hf, z);
}

void copyMap(const int (&from)[MAPXSIZE][MAPYSIZE], int (&to)[MAPXSIZE][MAPYSIZE])
{
  for (int y = 0;y < MAPYSIZE;y++)
  {
    for (int x = 0;x < MAPXSIZE;x++)
    {
      to[x][y] = from[x][y];
    }
  }
} 

void heightField(int (&useing)[MAPXSIZE][MAPYSIZE], int force)
{
  int workBuffer[MAPXSIZE][MAPYSIZE];

  for (int y = 0;y < MAPYSIZE;y++)
  {
    for (int x = 0;x < MAPXSIZE;x++)
    {
      useing[x][y] = random(1000);
    }
  }

  // attempt to get desired layout
  if (force)
  {
    // big block in the center for a huge asteroid
    forceSeed(useing, 6, 4, 14, 6, 650);

    // corners are getting farther away, should be clear
    forceSeed(useing, 0, 0, 0, 0, 0);
    forceSeed(useing, 0, 9, 0, 9, 0);
    forceSeed(useing, 19, 0, 19, 0, 0);
    forceSeed(useing, 19, 9, 19, 9, 0);

    // start and end places, easy and hard respectivly.
    forceSeed(useing, 0, 5, 1, 5, 0);
    forceSeed(useing, 18, 5, 19, 5, 500);
  }

  for (int i = 0;i < 2;i++)
  {
    finiteDifference(useing, workBuffer);
    finiteDifference(workBuffer, useing);
  }
}

void finiteDifference(int (&from)[MAPXSIZE][MAPYSIZE], int (&to)[MAPXSIZE][MAPYSIZE])
{
  int sum, sides;
  for (int y = 0;y < MAPYSIZE;y++)
  {
    for (int x = 0;x < MAPXSIZE;x++)
    {
      sides = 4;
      sum = 4 * from[x][y];
      if (x != 0)
      {
        sum += from[x-1][y];
        sides++;
      }
      if (x != 19)
      {
        sum += from[x+1][y];
        sides++;
      }
      if (y != 0)
      {
        sum += from[x][y-1];
        sides++;
      }
      if (y != 9)
      {
        sum += from[x][y+1];
        sides++;
      }
      to[x][y] = sum/sides;
    }
  }
}

void forceSeed(int (&useing)[MAPXSIZE][MAPYSIZE], int left, int top,
  int right, int bottom, int what)
{
  for (int y = top;y <= bottom;y++)
  {
    for (int x = left;x <= right;x++)
      useing[x][y] = what;
  }
}

void reduceHeightField(int (&useing)[MAPXSIZE][MAPYSIZE])
{
  int zoneHeight[NUMZONES];
  int which, a, b;

  for (a = 0;a < NUMZONES;a++)
    zoneHeight[a] = 0;
  zoneHeight[Z_EMPTY] =    325;
  zoneHeight[Z_SLOWROCK] = 75;
  zoneHeight[Z_MEDROCK] =  75;
  zoneHeight[Z_FASTROCK] = 75;
  zoneHeight[Z_FASTHUNK] = 50;
  zoneHeight[Z_SOLID] =    400;

  for (int y = 0;y < MAPYSIZE;y++)
  {
    for (int x = 0;x < MAPXSIZE;x++)
    {
      b = 0;
      for (which = Z_EMPTY;which < NUMZONES;which++)
      {
        b += zoneHeight[which];
        if (useing[x][y] <= b)
          break;
      }
      useing[x][y] = which;
    }
  }
}

int findShortestPath(int (&useing)[MAPXSIZE][MAPYSIZE])
{
  int tagArray[MAPXSIZE][MAPYSIZE];
  const int UNVISITED = 30000;

  for (int y = 0;y < MAPYSIZE;y++)
  {
    for (int x = 0;x < MAPXSIZE;x++)
      tagArray[x][y] = UNVISITED;
  }

  if (useing[0][5] == Z_SOLID)
    return UNVISITED;

  tagArray[0][5] = 0;

  int iterations = MAPXSIZE*(MAPYSIZE/2)+1; // worst case senario, 'snake'
  while (--iterations > 0 && tagArray[19][5] == UNVISITED)
  {
    for (int y = 0;y < MAPYSIZE;y++)
    {
      for (int x = 0;x < MAPXSIZE;x++)
      {
        if (useing[x][y] != Z_SOLID)
        {
          if (x != 0 && useing[x-1][y] != Z_LEFT)
            if (tagArray[x][y] > tagArray[x-1][y] + 3)
              tagArray[x][y] = tagArray[x-1][y] + 3;

          if (x != 19 && useing[x+1][y] != Z_RIGHT)
            if (tagArray[x][y] > tagArray[x+1][y])
              tagArray[x][y] = tagArray[x+1][y] + 3;

          if (y != 0 && useing[x][y-1] != Z_TOP)
            if (tagArray[x][y] > tagArray[x][y-1] + 1)
              tagArray[x][y] = tagArray[x][y-1] + 1;

          if (y != 9 && useing[x][y+1] != Z_BOTTOM)
            if (tagArray[x][y] > tagArray[x][y+1] + 1)
              tagArray[x][y] = tagArray[x][y+1] + 1;
        }
      }
    }
  }

  return tagArray[19][5];
}

void makeTunnel(int (&useing)[MAPXSIZE][MAPYSIZE])
{
  int wallCount = 0;
  int typeNum[NUMZONES];
  int takeOrder[MAPXSIZE] = {
    Z_BOSS, Z_SLOWWALL, Z_MEDWALL, Z_FASTWALL, Z_FASTMINE,
    Z_MEDWALL, Z_FASTWALL, Z_MEDWALL, Z_FASTWALL, Z_SLOWWALL,
    Z_FASTMINE, Z_MEDWALL, Z_FASTWALL, Z_MEDWALL, Z_FASTWALL,
    Z_SLOWWALL, Z_FASTMINE, Z_SECRET, Z_BOSS, Z_BOSS};
  int useOrder[6] = {Z_BOSS, Z_FASTMINE, Z_FASTWALL, Z_SECRET,
    Z_MEDWALL, Z_SLOWWALL};

  for (int a = 0;a < NUMZONES;a++)
    typeNum[a] = 0;

  // identify the pathway
  int x, y = 5;
  for (x = 0;x < MAPXSIZE;x++)
  {
    if (useing[x][y] == Z_SOLID || useing[x][y] == Z_FASTHUNK)
    {
      if ( (useing[x][y-1] == Z_SOLID || useing[x][y-1] == Z_FASTHUNK)
        && (useing[x][y+1] == Z_SOLID || useing[x][y+1] == Z_FASTHUNK) )
      {
        useing[x][y] = Z_SLOWWALL;
        wallCount++;
      }
      else
        useing[x][y] = Z_FASTHUNK;
    }
  }

  // change nearby hunks to halfs
  for (x = 0;x < MAPXSIZE;x++)
  {
    if (useing[x][y] == Z_SLOWWALL)
    {
      if (useing[x][y-1] == Z_FASTHUNK)
        useing[x][y-1] = Z_TOP;
      if (useing[x][y+1] == Z_FASTHUNK)
        useing[x][y+1] = Z_BOTTOM;
    }
  }

  // count up the types of each piece
  while (wallCount-- > 0)
    typeNum[takeOrder[wallCount]]++;

  // place the pieces
  x = MAPXSIZE;
  for (int p = 0;p < 6;p++)
  {
    while (typeNum[useOrder[p]] > 0)
    {
      if (--x < 0) // this should never happen, but just in case.
      {
        cputs("uh-oh!\r\n");
        getch();
        break;
      }
      if (useing[x][y] == Z_SLOWWALL)
      {
        useing[x][y] = useOrder[p];
        typeNum[useOrder[p]]--;
      }
    }
  }
}

void hunksToEdges(int (&useing)[MAPXSIZE][MAPYSIZE])
{
  const SL = 0, ST = 1, SR = 2, SB = 3;
  int side = SL, s;

  for (int y = 0;y < MAPYSIZE;y++)
  {
    for (int x = 0;x < MAPXSIZE;x++)
    {
      if (useing[x][y] == Z_FASTHUNK)
      {
        side = random(4) + 1;
        if (side < SL)
          side = SL;
        if (side > SB)
          side = SB;
        for (s = 0;s < 4;s++)
        {
          switch(side)
          {
            case SL:
              if (x != 0)
              {
                if (useing[x-1][y] == Z_SOLID)
                {
                  useing[x][y] = Z_RIGHT;
                  s = 4;
                }
              }
              break;
            case SR:
              if (x != 19)
              {
                if (useing[x+1][y] == Z_SOLID)
                {
                  useing[x][y] = Z_LEFT;
                  s = 4;
                }
              }
              break;
            case ST:
              if (y != 0)
              {
                if (useing[x][y-1] == Z_SOLID)
                {
                  useing[x][y] = Z_BOTTOM;
                  s = 4;
                }
              }
              break;
            case SB:
              if (y != 9)
              {
                if (useing[x][y+1] == Z_SOLID)
                {
                  useing[x][y] = Z_TOP;
                  s = 4;
                }
              }
              break;
          }
          if (++side > SB)
            side = SL;
        }
        if (useing[x][y] == Z_FASTHUNK)
        {
          switch(random(3))
          {
            case 0: useing[x][y] = Z_SLOWHUNK; break;
            case 1: useing[x][y] = Z_MEDHUNK; break;
            case 2: useing[x][y] = Z_FASTHUNK; break;
          }
        }
        // randomly adjust difficulty, so not all hard.
      }
    }
  }
}

void chooseZoneType(int (&useing)[MAPXSIZE][MAPYSIZE])
{
  int zoneProb[NUMZONES];
  int which;
  int a, b;

  for (a = 0;a < NUMZONES;a++)
    zoneProb[a] = 0;

  zoneProb[Z_EMPTY] =     1;
  zoneProb[Z_SLOWROCK] =  50;
  zoneProb[Z_SLOWCOMET] = 15;
  zoneProb[Z_SLOWWARP] =  15;
  zoneProb[Z_SLOWMINE] =  5;
  zoneProb[Z_DISTROCK] =  4;
  zoneProb[Z_DISTWARP] =  2;
  zoneProb[Z_DISTCOMET] = 3;
  zoneProb[Z_SLOWHUNK] =  5;
  zoneProb[Z_SOLID] =     1;

  for (int y = 0;y < MAPYSIZE;y++)
  {
    for (int x = 0;x < MAPXSIZE;x++)
    {
      a = random(100)+1;
      b = 0;
      for (which = Z_EMPTY;which < NUMZONES;which++)
      {
        b += zoneProb[which];
        if (a <= b)
          break;
      }
      useing[x][y] = which;
    }
  }
}

void mergeZones(int (&hf)[MAPXSIZE][MAPYSIZE],
  const int (&ztype)[MAPXSIZE][MAPYSIZE])
{
  for (int y = 0;y < MAPYSIZE;y++)
  {
    for (int x = 0;x < MAPXSIZE;x++)
    {
      if (hf[x][y] == Z_SLOWROCK)
      {
        hf[x][y] = ztype[x][y];
      }
      else if (hf[x][y] == Z_MEDROCK)
      {
        switch(ztype[x][y])
        {
          case Z_SLOWROCK: break;
          case Z_SLOWCOMET: hf[x][y] = Z_MEDCOMET; break;
          case Z_SLOWWARP: hf[x][y] = Z_MEDWARP; break;
          case Z_SLOWMINE: hf[x][y] = Z_SLOWMINE; break;
          case Z_SLOWHUNK: hf[x][y] = Z_MEDHUNK; break;
          default: hf[x][y] = ztype[x][y]; break;
        }
      }
      else if (hf[x][y] == Z_FASTROCK)
      {
        switch(ztype[x][y])
        {
          case Z_SLOWROCK: break;
          case Z_SLOWCOMET: hf[x][y] = Z_FASTCOMET; break;
          case Z_SLOWWARP: hf[x][y] = Z_FASTWARP; break;
          case Z_SLOWMINE: hf[x][y] = Z_MEDMINE; break;
          case Z_SLOWHUNK: hf[x][y] = Z_FASTHUNK; break;
          default: hf[x][y] = ztype[x][y]; break;
        }
      }
    }
  }
}
