// menu.h
//  game menu

#ifndef MENU_H
#define MENU_H

#include "gamefunc.h"

class MenuItem
{
public:
  MenuItem(char* name = NULL, int id = 0, int efc = WHITE, int dfc = DARKGRAY,
    int enable = 1, int hide = 0)
    : eForeColor(efc), dForeColor(dfc), tag(id), enabled(enable),
    hidden(hide), copy(NULL)
    {setMenuText(name);}
  ~MenuItem(void);

  void changeColorTo(int efc, int dfc = -1)
    {if (efc != -1) eForeColor = efc; if (dfc != -1) dForeColor = dfc;}
  void display(int x, int y, int bc);
  int select(void)
    {if (enabled) return tag; else return -1;}
  void setEnabled(int toWhat)
    {enabled = toWhat ? 1 : 0;}
  int isEnabled(void)
    {return enabled;}
  void setHidden(int toWhat)
    {hidden = toWhat ? 1 : 0;}
  int isHidden(void)
    {return hidden;}

  void lookLike(MenuItem* what)
    {copy = what;}

protected:
  int eForeColor, dForeColor, tag, enabled, hidden;
  char* menuText;
  MenuItem* copy;

  void setMenuText(char* name);
};

class Menu
{
public:
  Menu(void);
  ~Menu(void);

  void display(void);
  int update();
  void addItem(MenuItem *what);
  void place(int x, int y)
    {ulx = x; uly = y;}
  void setColors(int hl, int norm)
    {highlight = hl; normal = norm;}
  void home(void)
    {currentItem = 0;}

protected:
  int ulx, uly;
  int highlight, normal;
  int currentItem, maxItem;
  MenuItem* items[25];
};

#endif
