//the METE@RS game and related functions

#include "gamefunc.h"
#include "escfp23x.h"
#include "meteors.h"

//for game B: tells you when you are in trouble
void byebye(int sec, int r)
{
  int a;

  char m[7][6] = {{"     "},{"kiss "},{"your "},{"sorry"},{"butt "},{"good-"},{"bye. "}};
  if (sec == 1 && (r == 1 || r == 3))
  {
    for (a = 0; a < 30;a++)
    {
      if (a % 2 == 0) speaker.play(1000);
      delay(50);
      speaker.stop();
    }
    for (a = 0; a < 6;a++)
    {
      cset(a);
      gotoxy(27,22);
      cputs("    ");
      cputs(m[a]);
      cputs("     ");
      cset(a+1);
      gotoxy(27,23);
      cputs("    ");
      cputs(m[a+1]);
      cputs("     ");
      delay(400);
    }
  }
}

// C++ version of my METE@RS game

int meteors(void)
{
  int death, gamestat, dx, x, y, ymax, sx, sy, round, rtime, frameRate;
  int mx, my, color = 18, mvalue, grid[23][24], section[5];
  int gamespeed, repair[5] = {0,4,2,1,3};
  int a, b;
  const int BASESPEED = 13;
  // grid[][] is 1, 2, 3 if nothing, or 11, 12, 13  if a solid object

  start:
  death = 0;
  gamestat = 0;
  dx = 0;
  x = 10;
  y = 18;
  ymax = 18;
  sx = 0;
  sy = 0;
  round = 0;
  rtime = -1;
  sections = 5;
  frameRate = BASESPEED;
  gamespeed = BASESPEED;
  cset(RED);
  clrscr();

  for (a = 0;a < 5;a++) section[a] = 0;

  for (a = 0; a < 23;a++) for (b = 0;b < 24;b++)
    grid[a][b] = random(3)+1;
  for (a = 0; a < 23;a++) for (b = 0; b < random(6);b++)
    grid[a][23-b] += 10;
  cset(LIGHTGRAY);
  gotoxy(1,1);
  for (a = 1; a < 1000;a++) putch(random(3)+176);
  gotoxy(27,22);
  cset(WHITE);
  cputs("              ");
  gotoxy(27,23);
  cputs("              ");
  cset(RED, BROWN);
  for (b = 0;b<10;b++)
  {
    gotoxy(27,10+b);
    cputs("          ");
  }
  for (a = 25;a > 18;a--)
  {
    gotoxy(26, a);
    putch(219); //219 is a solid block
  }
  for (a = 0; a < 23;a++) for (b = 0; b < 24;b++)
  {
    gotoxy(a+2,b+1);
    if (grid[a][b] >= 11)
    {
      cset(LIGHTGRAY);
      putch(165+grid[a][b]);
    }
    else
    {
      cset(RED, BROWN);
      putch(175+grid[a][b]);
    }
  }
  cset(BLACK, RED);
  gotoxy(26,ymax);
  putch(17);

  readysetgo(gamestat, (int)'^');

  frameControl.set(frameRate);
  frameControl.sync();

  do {

//character section
  if (dx == -1)
  {
    gotoxy(x+6,y);
    cset(RED, BROWN);
    putch(175 + grid[x+4][y-1]);
  }
  else if (dx == 1)
  {
    gotoxy(x,y);
    cset(RED, BROWN);
    putch(175 + grid[x-2][y-1]);
  }
  if (death == 0)
  {
    dx = 0;
    switch (getkey())
    {
      case UP: if (y - 1 >= ymax)
           {
          cset(RED, BROWN);
          gotoxy(x+1,y);
          for (a=0;a<5;a++) putch(grid[x-1+a][y-1]+175);
          y--;
           }
         break;
      case DOWN: b = 0;
           for (a=0;a<5;a++) if (grid[x-1+a][y] > 10 || y+1 == 25) b = 1;
          if (b == 0)
          {
            cset(RED, BROWN);
            gotoxy(x+1,y);
            for (a=0;a<5;a++) putch(grid[x-1+a][y-1]+175);
            y++;
          }
           break;
      case LEFT: dx = -1; break;
      case RIGHT: dx = 1; break;
      case ESCAPE: pause(gamestat); break;
    }
    if (dx == -1 && (grid[x-2][y-1] > 10 || (mx == x-1 && my == y) || x + dx == 0))
    {
      if (section[0] == 0)
      {
        sections--;
        byebye(sections, round);
      }
      section[0] = 1;
      speaker.play(50);
      dx = 0;
    }
    if (dx == 1 && (grid[x+4][y-1] > 10 || (mx == x+5 && my == y) || x + dx == 20))
    {
      if (section[4] == 0)
      {
        sections--;
        byebye(sections, round);
      }
      section[4] = 1;
      speaker.play(50);
      dx = 0;
    }
    x += dx;
    if (my == y - 1 && (mx >= x && mx <= x + 4))
    {
      if (color == BROWN)
      {
        speaker.play(200);
        if (section[mx-x] == 0)
        {
          sections--;
          byebye(sections, round);
        }
        section[mx-x] = 1;
        cset(RED, BROWN);
        if (my-3 > 1)
        {
          gotoxy(mx+1,my-3);
          putch(175 + grid[mx-1][my-3]);
        }
        if (my-2 > 1)
        {
          gotoxy(mx+1,my-2);
          putch(175 + grid[mx-1][my-3]);
        }
        if (my-1 > 1)
        {
          gotoxy(mx+1,my-1);
          putch(175 + grid[mx-1][my-2]);
        }
        gotoxy(mx+1,my);
        putch(175  + grid[mx-1][my-1]);
        color = 18;
      }
      else if (color == 17)
      {
        if (section[mx-x] == 0)
        {
          cset(RED, BROWN);
          gotoxy(mx+1,my);
          putch(175  + grid[mx-1][my-1]);
          color = 18;
          b = 0;
          for (a = 0; a < 5;a++)
          {
            if (section[repair[a]] == 1 && b == 0)
            {
              speaker.play(500);
              sections++;
              section[repair[a]] = 0;
              b = 1;
            }
          }
        }
      }
      else
      {
        if (section[mx-x] == 0)
        {
        if (color == BLACK) mvalue = RED;
        else mvalue = color;
        speaker.play(50*mvalue);
        switch(difficulty)
        {
          case D_EASY:
            mvalue *= 2;
            break;
          case D_MEDIUM:
            mvalue = (int)((float)mvalue * 1.5);
            break;
          case D_HARD:
            //mvalue *= 1;
            break;
          case D_RIDICULOUS:
            mvalue = (int)((float)mvalue *0.75) + 1;
            break;
        }
        cset(color, BROWN);
        for (a = 0;a < mvalue;a++)
        {
          gotoxy(27+sx,10+sy);
          putch('@');
          sx++;
          if (sx >= 10)
          {
            sx = 0;
            sy++;
          }
          if (sy >= 10)
          {
            sy = 0;
            for (b = 0;b<10;b++)
            {
              gotoxy(27,10+b);
              cputs("          ");
            }
            b = 0;
            for (int c = 0; c < 5;c++)
            {
              if (section[repair[c]] == 1 && b == 0)
              {
                speaker.play(500);
                sections++;
                section[repair[c]] = 0;
                b = 1;
              }
            }
            if (b == 0)
            {
              gotoxy(26,ymax);
              cset(BLACK, RED);
              putch(' ');
              if (ymax > 2)
              {
                ymax--;
                gotoxy(26,ymax);
                putch(17);
                cset(color, BROWN);
              }
              if (ymax == 2)
              {
                cset(YELLOW + BLINK, RED);
                gotoxy(26,ymax);
                putch(17);
              }
            }
            if (ymax == 2)
            {
              cset(BLACK, RED);
              gotoxy(27, 22);
              cputs("reach the top ");
              gotoxy(27, 23);
              cputs("to blast off  ");
              beepbeep(50, 50, 4);
            }
          }
        }
        }
        cset(RED, BROWN);
        gotoxy(mx+1,my);
        putch(175  + grid[mx-1][my-1]);
        color = 18;
      }
    }
    gotoxy(x+1,y);
    for (a = 0;a < 5;a++)
    {
      cset(LIGHTGRAY, BROWN);
      if (section[a] <= 0) putch(202);
      if (section[a] >= 1) putch(205);
    }
    if (dx == -1)
    {
      gotoxy(x+6,y);
      cset(YELLOW, BROWN);
      putch(17);
    }
    else if (dx == 1)
    {
      gotoxy(x,y);
      cset(YELLOW, BROWN);
      putch(16);
    }
    switch(difficulty)
    {
      case D_EASY:
        frameControl.set(frameRate*0.8);
        break;
      case D_MEDIUM:
        frameControl.set(frameRate);
        break;
      case D_HARD:
        frameControl.set(frameRate*1.2);
        break;
      case D_RIDICULOUS:
        frameControl.set(frameRate*1.4);
        break;
    }
    frameControl.force();
    speaker.stop();
  }
  if (sections == 5 && y == 2)
    gamestat = 2;
  if (sections != 5 && y == 2)
    gamestat = 4;
  if (sections == 0)
  {
    death = 1;
    gamestat = 1;
  }

//meteor section
  if (color == 18)
  {
    if (rtime <= -100) rtime = -1;
    if (rtime-- == 0)
    {
      round = 0;
      frameRate = BASESPEED;
      gamespeed = BASESPEED;
      cset(RED + BLINK);
      gotoxy(27,22);
      cputs("   ALL CLEAR  ");
      gotoxy(27,23);
      cputs("              ");
      beepbeep(500, 100, 20);
      gotoxy(27,22);
      cputs("             ");
    }

    if (round == 1) color = BROWN;
    else if (round == 2) color = 17;
    else if (round == 3)
    {
      color = random(16);
      if (color == RED) color = BROWN;
    }
    else
    {
      color = random(17);
      if (color == BROWN) color = RED;
      if (color == 16)
      {
        switch(difficulty)
        {
          case D_EASY:
            b = random(ymax);
            break;
          case D_MEDIUM:
            b = random(ymax/2 + 1);
            break;
          case D_HARD:
            b = random(ymax/4 + 2);
            break;
          case D_RIDICULOUS:
            b = random(ymax/8 + 2);
            break;
        }
        if (random(sections*sections) == 0)
        {
          round = 2;
          rtime = 10;
          color = 17;
          cset(RED + BLINK);
          gotoxy(27,22);
          cputs(" MERCY: don't ");
          gotoxy(27,23);
          cputs(" waste it...  ");
          beepbeep(50, 100, 30);
        }
        else if (b == 0)
        {
          round = 1;
          rtime = 20;
          color = BROWN;
          cset(RED + BLINK);
          gotoxy(27,22);
          cputs(" COMET SHOWER ");
          gotoxy(27,23);
          cputs("CEWS overload ");
          beepbeep(100, 100, 30);
        }
        else if (b == 1)
        {
          round = 3;
          rtime = 50;
          gamespeed = (int)( (float)BASESPEED * 2 );
          color = random(16);
          if (color == BROWN) color = RED;
          cset(RED + BLINK);
          gotoxy(27,22);
          cputs("    TURBO     ");
          gotoxy(27,23);
          cputs("CEWS overload ");
          beepbeep(100, 50, 40);
        }
        else
        {
          color = random(16);
          if (color == BROWN) color = RED;
        }
        byebye(sections, round);
       }
    }
    startover:
    mx = random(23)+1;
    if (grid[mx-1][1] > 10) goto startover;
    my = 1;
  }

  if (color == RED)
  {
    frameRate = BASESPEED;
    gotoxy(mx+1,1);
    cset(GREEN+BLINK,BROWN);
    putch(30);
    if (my % 2 == 0) speaker.play(400);
    my--;
    if (my == -14)
    {
      gotoxy(mx+1,1);
      cset(RED,BROWN);
      putch(grid[mx-1][0]+175);
      my = 1;
      color = BROWN;
    }
  }
  else if (color == BROWN)
  {
    cset(RED,BROWN);
    if (grid[mx-1][my] > 10 || my+1 == 25)
    {
      if (grid[mx-1][my] > 10)
      {
        grid[mx-1][my] -=10;
        gotoxy(mx+1,my+1);
        putch(grid[mx-1][my] + 175);
      }

      if (my-3 > 1)
      {
        gotoxy(mx+1,my-3);
        putch(175 + grid[mx-1][my-3]);
      }
      if (my-2 > 1)
      {
        gotoxy(mx+1,my-2);
        putch(175 + grid[mx-1][my-3]);
      }
      if (my-1 > 1)
      {
        gotoxy(mx+1,my-1);
        putch(175 + grid[mx-1][my-2]);
      }
      gotoxy(mx+1,my);
      putch(175  + grid[mx-1][my-1]);
      color = 18;
      speaker.play(25);
      delay(25);
      speaker.play(100);
      delay(25);
      speaker.play(25);
      delay(25);
      speaker.play(100);
      delay(25);  
    }
    else
    {
      frameRate = BASESPEED * 2;
      if (my-3 > 1)
      {
        gotoxy(mx+1,my-3);
        putch(grid[mx-1][my-4]+175);
      }
      if (my % 2 == 0) speaker.play(100);
      my++;
      cset(WHITE,BROWN);
      if (my-3 > 1)
      {
        gotoxy(mx+1,my-3);
        putch(176);
      }
      if (my-2 > 1)
      {
        gotoxy(mx+1,my-2);
        putch(177);
      }
      if (my-1 > 1)
      {
        gotoxy(mx+1,my-1);
        putch(178);
      }
      gotoxy(mx+1,my);
      putch('@');
     }
  }
  else if (color == 17)
  {
    frameRate = BASESPEED;
    gotoxy(mx+1,my);
    cset(RED,BROWN);
    putch(grid[mx-1][my-1] + 175);
    my++;
    gotoxy(mx+1,my);
    cset(random(17),BROWN);
    putch('R');
    if (my+1== 25 || grid[mx-1][my] > 10)
    {
      cset(RED, BROWN);
      if (grid[mx-1][my] > 10)
      {
        grid[mx-1][my] -= 10;
        gotoxy(mx+1,my+1);
        putch(grid[mx-1][my] + 175);
      }
      gotoxy(mx+1,my);
      putch(grid[mx-1][my-1] + 175);
      color = 18;
      speaker.play(25);
      delay(25);
      speaker.play(100);
      delay(25);
      speaker.play(25);
      delay(25);
      speaker.play(100);
      delay(25);
    }
  }
  else
  {
    frameRate = gamespeed + color/4;
    gotoxy(mx+1,my);
    cset(RED,BROWN);
    putch(grid[mx-1][my-1] + 175);
    my++;
    gotoxy(mx+1,my);
    cset(color,BROWN);
    putch('@');
    if (my+1 == 25 || grid[mx-1][my] > 10)
    {
      color = 18;
      grid[mx-1][my-1] += 10;
      speaker.play(100);
    }
  }
//end meteor section
  } while (gamestat == 0);
  speaker.stop();
  if (gamestat == 1)
    explode(x+2,y);

  return gamestat;
}

void meteors_instructions(void)
{
  do {
  } while (getkey());
  titlebar("game B: METE@RS", 12, 12);
  cset(LIGHTMAGENTA);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  cputs("             The Story.                 ");
  cputs("After proving your right to live and    ");
  cputs("being released from the alien's custody,");
  cputs("you found your lander craft in a steep- ");
  cputs("walled valley.  The batteries had been  ");
  cputs("greatly drained, and while it could     ");
  cputs("hover, there was not enough power to    ");
  cputs("return to your main ship.  While        ");
  cputs("pondering the problem, a sudden meteor  ");
  cputs("shower began to fall.  The meteorites   ");
  cputs("will soon pile up past your hovering    ");
  cputs("height.  However, the meteors are pure  ");
  cputs("minerals and if caught, they can be     ");
  cputs("converted into energy by your fusion    ");
  cputs("generator.  Different meteors are worth ");
  cputs("different amounts of energy.  For every ");
  cputs("100 \"points\" of energy, you will either ");
  cputs("repair your craft or raise your maximum ");
  cputs("height.  As well as meteors, there are  ");
  cputs("comets which can damage your ship,      ");
  cputs("luckily, you have a Comet Early Warning ");
  cputs("System (CEWS -- you need to know that), ");
  cputs("but it overloads in some special rounds. ");
  cset(GREEN);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  getch();

  titlebar("game B: METE@RS", 12, 12);
  cset(LIGHTMAGENTA);
  //     0000000001111111111222222222233333333334
  //     1234567890123456789012345678901234567890
  cputs("           The Instructions.            ");
  cputs("--The arrow keys move your ship.        ");
  cputs(" -Watch out for walls & meteors on your ");
  cputs("  sides, but moving down is safe.       ");
  cputs(" -You can't move higher than your max   ");
  cputs("  height -- the red bar to the right.   ");
  cputs("--The green arrow at the top of the pit ");
  cputs("  is CEWS warning of an incoming comet. ");
  cputs("--The brown area to the right shows how ");
  cputs("  many \"points\", out of one-hundred,    ");
  cputs("  you have collected from meteors.      ");
  cputs(" -Whenerver this fills, 1 damaged       ");
  cputs("  section of your ship will be repaired.");
  cputs(" -If you are in good condition, your    ");
  cputs("  maximum height will increase.         ");
  cputs("--A message at lower right usually means");
  cputs("  a special round is begining or ending ");
  cputs("  COMET SHOWER -- Only comets fall, CEWS");
  cputs("                  is overloaded here.   ");
  cputs("  TURBO -- Meteors and comets fall super");
  cputs("           fast, CEWS is also out.      ");
  cputs("  MERCY -- Junk from an unfortunate ship");
  cputs("           falls, it fixes one section. ");
  cset(GREEN);
  cputs("       --PRESS A KEY TO CONTINUE--    ");
  getch();
}

//ending sequence for game B
void endgameB(void)
{
  int a, b;

  cset(WHITE);
  clrscr();
  for (a = 1;a < 910;a++)
  {
    if (random(40) == 0) putch(250);
    else if (random(40) == 0) putch(249);
    else putch(' ');
  }
  gotoxy(1,20);
  for (a = 20;a < 25;a++) for (b = 0;b < 40;b++)
  {
    if (b > 8 && b < 31) cset(RED, BROWN);
    else cset(LIGHTGRAY);
    putch(random(3)+176);
  }
  gotoxy(16,19);
  for (a = 0;a < 5;a++) putch(202);
  for (a = 5;a < 9;a++)
  {
    for (b = a*100;b < (a+1)*100;b++)
    {
      speaker.play(b);
      delay(20);
    }
    gotoxy(16,24-a);
    cputs("     ");
    gotoxy(16,23-a);
    for (int c = 0;c < 5;c++) putch(202);
  }
  for (b = 900;b < 1000;b++)
  {
    speaker.play(b);
    delay(20);
  }
  for (a = 0;a < 14;a++)
  {
    speaker.play(100-(a*4));
    cset(LIGHTGRAY);
    gotoxy(16,15-a);
    for (b = 0;b < 5;b++) putch(202);
    gotoxy(16,17-a);
    for (b = 0;b < 5;b++) putch(178);
    cset(RED, LIGHTGRAY);
    gotoxy(16,16-a);
    for (b = 0;b < 5;b++) putch(31);
    delay(100);
  }
  cset(LIGHTGRAY);
  gotoxy(16, 1);
  for (b = 0;b < 5;b++) putch(178);
  gotoxy(16, 2);
  for (b = 0;b < 5;b++) putch(178);
  for (a = 0;a < 17;a++)
  {
    gotoxy(16,17-a);
    for (b = 0;b < 5;b++) putch(177);
    delay(10);
  }
  for (a = 0;a < 17;a++)
  {
    gotoxy(16,17-a);
    for (b = 0;b < 5;b++) putch(176);
    delay(10);
  }
  for (a = 0;a < 17;a++)
  {
    gotoxy(16,17-a);
    cputs("     ");
    delay(10);
  }
  delay(1000);
  speaker.stop();
}
